# StatsFuns.jl

Mathematical functions related to statistics.

[![CI](https://github.com/JuliaStats/StatsFuns.jl/actions/workflows/ci.yml/badge.svg?branch=master)](https://github.com/JuliaStats/StatsFuns.jl/actions/workflows/ci.yml?query=branch%3Amaster)
[![codecov](https://codecov.io/gh/JuliaStats/StatsFuns.jl/branch/master/graph/badge.svg?token=CV9hGTr6cW)](https://codecov.io/gh/JuliaStats/StatsFuns.jl)
[![code style: runic](https://img.shields.io/badge/code_style-%E1%9A%B1%E1%9A%A2%E1%9A%BE%E1%9B%81%E1%9A%B2-black)](https://github.com/fredrikekre/Runic.jl)

This package provides a collection of mathematical constants and numerical functions for statistical computing.

## Constants

```julia
twoπ,       # 2π
fourπ,      # 4π
halfπ,      # π / 2
quartπ,     # π / 4
invπ,       # 1 / π
twoinvπ,    # 2 / π
fourinvπ,   # 4 / π
inv2π,      # 1 / (2π)
inv4π,      # 1 / (4π)
sqrt2,      # √2
sqrt3,      # √3
sqrtπ,      # √π
sqrt2π,     # √2π
sqrt4π,     # √4π
sqrthalfπ,  # √(π / 2)
invsqrt2,   # 1 / √2
invsqrt2π,  # 1 / √2π
loghalf,    # log(1 / 2)
logtwo,     # log(2)
logπ,       # log(π)
log2π,      # log(2π)
log4π,      # log(4π)
```

## Basic Functions

```julia
# basicfuns
xlogx,          # x * log(x), or 0 when x is zero
xlogy,          # x * log(y), or 0 when x is zero
xlog1py,        # x * log(1 + y) for x > 0, or 0 when x == 0
logistic,       # 1 / (1 + exp(-x))
logit,          # log(x / (1 - x))
log1psq,        # log(1 + x^2)
log1pexp,       # log(1 + exp(x))
log1mexp,       # log(1 - exp(x))
log2mexp,       # log(2 - exp(x))
logexpm1,       # log(exp(x) - 1)
softplus,       # alias of log1pexp
invsoftplus,    # alias of logexpm1
log1pmx,        # log(1 + x) - x
logmxp1,        # log(x) - x + 1
logaddexp,      # log(exp(x) + exp(y))
logsubexp,      # log(abs(exp(x) - exp(y)))
logsumexp,      # log(sum(exp(x)))
softmax,        # exp(x_i) / sum(exp(x)), for i
softmax!,       # inplace softmax

# misc
logmvgamma,     # logarithm of multivariate gamma function
lstirling_asym,

owens_t         # Owen's T function
```

## Distribution-related functions

Do note that this package only provides low-level distribution functions. We recommend using the [Distributions.jl](https://github.com/JuliaStats/Distributions.jl/) package for a more convenient interface.

```julia
# distrs/beta
betapdf,            # pdf of beta distribution
betalogpdf,         # logpdf of beta distribution
betacdf,            # cdf of beta distribution
betaccdf,           # ccdf of beta distribution
betalogcdf,         # logcdf of beta distribution
betalogccdf,        # logccdf of beta distribution
betainvcdf,         # inverse-cdf of beta distribution
betainvccdf,        # inverse-ccdf of beta distribution
betainvlogcdf,      # inverse-logcdf of beta distribution
betainvlogccdf,     # inverse-logccdf of beta distribution

# distrs/binom
binompdf,           # pdf of binomial distribution
binomlogpdf,        # logpdf of binomial distribution
binomcdf,           # cdf of binomial distribution
binomccdf,          # ccdf of binomial distribution
binomlogcdf,        # logcdf of binomial distribution
binomlogccdf,       # logccdf of binomial distribution
binominvcdf,        # inverse-cdf of binomial distribution
binominvccdf,       # inverse-ccdf of binomial distribution
binominvlogcdf,     # inverse-logcdf of binomial distribution
binominvlogccdf,    # inverse-logccdf of binomial distribution

# distrs/chisq
chisqpdf,           # pdf of chi-square distribution
chisqlogpdf,        # logpdf of chi-square distribution
chisqcdf,           # cdf of chi-square distribution
chisqccdf,          # ccdf of chi-square distribution
chisqlogcdf,        # logcdf of chi-square distribution
chisqlogccdf,       # logccdf of chi-square distribution
chisqinvcdf,        # inverse-cdf of chi-square distribution
chisqinvccdf,       # inverse-ccdf of chi-square distribution
chisqinvlogcdf,     # inverse-logcdf of chi-square distribution
chisqinvlogccdf,    # inverse-logccdf of chi-square distribution

# distrs/fdist
fdistpdf,           # pdf of F distribution
fdistlogpdf,        # logpdf of F distribution
fdistcdf,           # cdf of F distribution
fdistccdf,          # ccdf of F distribution
fdistlogcdf,        # logcdf of F distribution
fdistlogccdf,       # logccdf of F distribution
fdistinvcdf,        # inverse-cdf of F distribution
fdistinvccdf,       # inverse-ccdf of F distribution
fdistinvlogcdf,     # inverse-logcdf of F distribution
fdistinvlogccdf,    # inverse-logccdf of F distribution

# distrs/gamma
gammapdf,           # pdf of gamma distribution
gammalogpdf,        # logpdf of gamma distribution
gammacdf,           # cdf of gamma distribution
gammaccdf,          # ccdf of gamma distribution
gammalogcdf,        # logcdf of gamma distribution
gammalogccdf,       # logccdf of gamma distribution
gammainvcdf,        # inverse-cdf of gamma distribution
gammainvccdf,       # inverse-ccdf of gamma distribution
gammainvlogcdf,     # inverse-logcdf of gamma distribution
gammainvlogccdf,    # inverse-logccdf of gamma distribution

# distrs/hyper
hyperpdf,           # pdf of hypergeometric distribution
hyperlogpdf,        # logpdf of hypergeometric distribution
hypercdf,           # cdf of hypergeometric distribution
hyperccdf,          # ccdf of hypergeometric distribution
hyperlogcdf,        # logcdf of hypergeometric distribution
hyperlogccdf,       # logccdf of hypergeometric distribution
hyperinvcdf,        # inverse-cdf of hypergeometric distribution
hyperinvccdf,       # inverse-ccdf of hypergeometric distribution
hyperinvlogcdf,     # inverse-logcdf of hypergeometric distribution
hyperinvlogccdf,    # inverse-logccdf of hypergeometric distribution

# distrs/nbeta
nbetapdf,           # pdf of noncentral beta distribution
nbetalogpdf,        # logpdf of noncentral beta distribution
nbetacdf,           # cdf of noncentral beta distribution
nbetaccdf,          # ccdf of noncentral beta distribution
nbetalogcdf,        # logcdf of noncentral beta distribution
nbetalogccdf,       # logccdf of noncentral beta distribution
nbetainvcdf,        # inverse-cdf of noncentral beta distribution
nbetainvccdf,       # inverse-ccdf of noncentral beta distribution
nbetainvlogcdf,     # inverse-logcdf of noncentral beta distribution
nbetainvlogccdf,    # inverse-logccdf of noncentral beta distribution

# distrs/nbinom
nbinompdf,           # pdf of negative nbinomial distribution
nbinomlogpdf,        # logpdf of negative nbinomial distribution
nbinomcdf,           # cdf of negative nbinomial distribution
nbinomccdf,          # ccdf of negative nbinomial distribution
nbinomlogcdf,        # logcdf of negative nbinomial distribution
nbinomlogccdf,       # logccdf of negative nbinomial distribution
nbinominvcdf,        # inverse-cdf of negative nbinomial distribution
nbinominvccdf,       # inverse-ccdf of negative nbinomial distribution
nbinominvlogcdf,     # inverse-logcdf of negative nbinomial distribution
nbinominvlogccdf,    # inverse-logccdf of negative nbinomial distribution

# distrs/nchisq
nchisqpdf,           # pdf of noncentral chi-square distribution
nchisqlogpdf,        # logpdf of noncentral chi-square distribution
nchisqcdf,           # cdf of noncentral chi-square distribution
nchisqccdf,          # ccdf of noncentral chi-square distribution
nchisqlogcdf,        # logcdf of noncentral chi-square distribution
nchisqlogccdf,       # logccdf of noncentral chi-square distribution
nchisqinvcdf,        # inverse-cdf of noncentral chi-square distribution
nchisqinvccdf,       # inverse-ccdf of noncentral chi-square distribution
nchisqinvlogcdf,     # inverse-logcdf of noncentral chi-square distribution
nchisqinvlogccdf,    # inverse-logccdf of noncentral chi-square distribution

# distrs/nfdist
nfdistpdf,           # pdf of noncentral F distribution
nfdistlogpdf,        # logpdf of noncentral F distribution
nfdistcdf,           # cdf of noncentral F distribution
nfdistccdf,          # ccdf of noncentral F distribution
nfdistlogcdf,        # logcdf of noncentral F distribution
nfdistlogccdf,       # logccdf of noncentral F distribution
nfdistinvcdf,        # inverse-cdf of noncentral F distribution
nfdistinvccdf,       # inverse-ccdf of noncentral F distribution
nfdistinvlogcdf,     # inverse-logcdf of noncentral F distribution
nfdistinvlogccdf,    # inverse-logccdf of noncentral F distribution

# distrs/norm
normpdf,            # pdf of normal distribution
normlogpdf,         # logpdf of normal distribution
normcdf,            # cdf of normal distribution
normccdf,           # ccdf of normal distribution
normlogcdf,         # logcdf of normal distribution
normlogccdf,        # logccdf of normal distribution
norminvcdf,         # inverse-cdf of normal distribution
norminvccdf,        # inverse-ccdf of normal distribution
norminvlogcdf,      # inverse-logcdf of normal distribution
norminvlogccdf,     # inverse-logccdf of normal distribution

# distrs/ntdist
ntdistpdf,           # pdf of noncentral t distribution
ntdistlogpdf,        # logpdf of noncentral t distribution
ntdistcdf,           # cdf of noncentral t distribution
ntdistccdf,          # ccdf of noncentral t distribution
ntdistlogcdf,        # logcdf of noncentral t distribution
ntdistlogccdf,       # logccdf of noncentral t distribution
ntdistinvcdf,        # inverse-cdf of noncentral t distribution
ntdistinvccdf,       # inverse-ccdf of noncentral t distribution
ntdistinvlogcdf,     # inverse-logcdf of noncentral t distribution
ntdistinvlogccdf,    # inverse-logccdf of noncentral t distribution

# distrs/pois
poispdf,           # pdf of Poisson distribution
poislogpdf,        # logpdf of Poisson distribution
poiscdf,           # cdf of Poisson distribution
poisccdf,          # ccdf of Poisson distribution
poislogcdf,        # logcdf of Poisson distribution
poislogccdf,       # logccdf of Poisson distribution
poisinvcdf,        # inverse-cdf of Poisson distribution
poisinvccdf,       # inverse-ccdf of Poisson distribution
poisinvlogcdf,     # inverse-logcdf of Poisson distribution
poisinvlogccdf,    # inverse-logccdf of Poisson distribution

# distrs/signrank
signrankpdf,           # pdf of signrank distribution
signranklogpdf,        # logpdf of signrank distribution
signrankcdf,           # cdf of signrank distribution
signrankccdf,          # ccdf of signrank distribution
signranklogcdf,        # logcdf of signrank distribution
signranklogccdf,       # logccdf of signrank distribution
signrankinvcdf,        # inverse-cdf of signrank distribution
signrankinvccdf,       # inverse-ccdf of signrank distribution
signrankinvlogcdf,     # inverse-logcdf of signrank distribution
signrankinvlogccdf,    # inverse-logccdf of signrank distribution

# distrs/tdist
tdistpdf,           # pdf of student's t distribution
tdistlogpdf,        # logpdf of student's t distribution
tdistcdf,           # cdf of student's t distribution
tdistccdf,          # ccdf of student's t distribution
tdistlogcdf,        # logcdf of student's t distribution
tdistlogccdf,       # logccdf of student's t distribution
tdistinvcdf,        # inverse-cdf of student's t distribution
tdistinvccdf,       # inverse-ccdf of student's t distribution
tdistinvlogcdf,     # inverse-logcdf of student's t distribution
tdistinvlogccdf,    # inverse-logccdf of student's t distribution

# distrs/wilcox
wilcoxpdf,           # pdf of Wilcox distribution
wilcoxlogpdf,        # logpdf of Wilcox distribution
wilcoxcdf,           # cdf of Wilcox distribution
wilcoxccdf,          # ccdf of Wilcox distribution
wilcoxlogcdf,        # logcdf of Wilcox distribution
wilcoxlogccdf,       # logccdf of Wilcox distribution
wilcoxinvcdf,        # inverse-cdf of Wilcox distribution
wilcoxinvccdf,       # inverse-ccdf of Wilcox distribution
wilcoxinvlogcdf,     # inverse-logcdf of Wilcox distribution
wilcoxinvlogccdf,    # inverse-logccdf of Wilcox distribution
```

## License

All of the code for this package is released under the MIT/Expat license, but this package depends upon the Rmath.jl package, which currently links to a GPL-licensed library. As such, the package currently constitutes a derived work. Work is underway to remove that dependency.

module StatsFunsChainRulesCoreExt

using StatsFuns
using SpecialFunctions: digamma, erf

import ChainRulesCore

ChainRulesCore.@scalar_rule(
    betalogpdf(α::Real, β::Real, x::Number),
    @setup(z = digamma(α + β)),
    (
        log(x) + z - digamma(α),
        log1p(-x) + z - digamma(β),
        (α - 1) / x + (1 - β) / (1 - x),
    ),
)

ChainRulesCore.@scalar_rule(
    binomlogpdf(n::Real, p::Real, k::Real),
    (
        ChainRulesCore.NoTangent(),
        (k / p - n) / (1 - p),
        ChainRulesCore.NoTangent(),
    ),
)

ChainRulesCore.@scalar_rule(
    chisqlogpdf(k::Real, x::Number),
    @setup(hk = k / 2),
    (
        (log(x) - logtwo - digamma(hk)) / 2,
        (hk - 1) / x - one(hk) / 2,
    ),
)

ChainRulesCore.@scalar_rule(
    fdistlogpdf(ν1::Real, ν2::Real, x::Number),
    @setup(
        xν1 = x * ν1,
        temp1 = xν1 + ν2,
        a = (x - 1) / temp1,
        νsum = ν1 + ν2,
        di = digamma(νsum / 2),
    ),
    (
        (-log1p(ν2 / xν1) - ν2 * a + di - digamma(ν1 / 2)) / 2,
        (-log1p(xν1 / ν2) + ν1 * a + di - digamma(ν2 / 2)) / 2,
        ((ν1 - 2) / x - ν1 * νsum / temp1) / 2,
    ),
)

ChainRulesCore.@scalar_rule(
    gammalogpdf(k::Real, θ::Real, x::Number),
    @setup(
        invθ = inv(θ),
        xoθ = invθ * x,
        z = xoθ - k,
    ),
    (
        log(xoθ) - digamma(k),
        invθ * z,
        - (1 + z) / x,
    ),
)

ChainRulesCore.@scalar_rule(
    poislogpdf(λ::Number, x::Number),
    ((iszero(x) && iszero(λ) ? zero(x / λ) : x / λ) - 1, ChainRulesCore.NoTangent()),
)

ChainRulesCore.@scalar_rule(
    tdistlogpdf(ν::Real, x::Number),
    @setup(
        νp1 = ν + 1,
        xsq = x^2,
        invν = inv(ν),
        a = xsq * invν,
        b = νp1 / (ν + xsq),
    ),
    (
        (digamma(νp1 / 2) - digamma(ν / 2) + a * b - log1p(a) - invν) / 2,
        - x * b,
    ),
)

ChainRulesCore.@scalar_rule(
    owens_t(h::Real, a::Real),
    (
        normpdf(h) * erf((h * a) * invsqrt2) / -2,
        inv2π * exp(-h^2 * (1 + a^2) / 2) / (1 + a^2),
    ),
)

end # module

module StatsFunsInverseFunctionsExt

using StatsFuns
import InverseFunctions

InverseFunctions.inverse(::typeof(normcdf)) = norminvcdf
InverseFunctions.inverse(::typeof(norminvcdf)) = normcdf

InverseFunctions.inverse(::typeof(normccdf)) = norminvccdf
InverseFunctions.inverse(::typeof(norminvccdf)) = normccdf

InverseFunctions.inverse(::typeof(normlogcdf)) = norminvlogcdf
InverseFunctions.inverse(::typeof(norminvlogcdf)) = normlogcdf

InverseFunctions.inverse(::typeof(normlogccdf)) = norminvlogccdf
InverseFunctions.inverse(::typeof(norminvlogccdf)) = normlogccdf

end # module

# functions related to hyper-geometric distribution

# Rmath implementations
function hyperpdf(ms::Real, mf::Real, n::Real, x::Real)
    T = float(Base.promote_typeof(ms, mf, n, x))
    return convert(T, Rmath.dhyper(x, ms, mf, n, false))
end
function hyperlogpdf(ms::Real, mf::Real, n::Real, x::Real)
    T = float(Base.promote_typeof(ms, mf, n, x))
    return convert(T, Rmath.dhyper(x, ms, mf, n, true))
end

function hypercdf(ms::Real, mf::Real, n::Real, x::Real)
    T = float(Base.promote_typeof(ms, mf, n, x))
    return convert(T, Rmath.phyper(x, ms, mf, n, true, false))
end
function hyperccdf(ms::Real, mf::Real, n::Real, x::Real)
    T = float(Base.promote_typeof(ms, mf, n, x))
    return convert(T, Rmath.phyper(x, ms, mf, n, false, false))
end
function hyperlogcdf(ms::Real, mf::Real, n::Real, x::Real)
    T = float(Base.promote_typeof(ms, mf, n, x))
    return convert(T, Rmath.phyper(x, ms, mf, n, true, true))
end
function hyperlogccdf(ms::Real, mf::Real, n::Real, x::Real)
    T = float(Base.promote_typeof(ms, mf, n, x))
    return convert(T, Rmath.phyper(x, ms, mf, n, false, true))
end

function hyperinvcdf(ms::Real, mf::Real, n::Real, q::Real)
    T = float(Base.promote_typeof(ms, mf, n, q))
    return convert(T, Rmath.qhyper(q, ms, mf, n, true, false))
end
function hyperinvccdf(ms::Real, mf::Real, n::Real, q::Real)
    T = float(Base.promote_typeof(ms, mf, n, q))
    return convert(T, Rmath.qhyper(q, ms, mf, n, false, false))
end
function hyperinvlogcdf(ms::Real, mf::Real, n::Real, lq::Real)
    T = float(Base.promote_typeof(ms, mf, n, lq))
    return convert(T, Rmath.qhyper(lq, ms, mf, n, true, true))
end
function hyperinvlogccdf(ms::Real, mf::Real, n::Real, lq::Real)
    T = float(Base.promote_typeof(ms, mf, n, lq))
    return convert(T, Rmath.qhyper(lq, ms, mf, n, false, true))
end

# default relative tolerance for comparisons with Rmath
function _default_rtol(params, X::AbstractArray)
    # has to take into account `params` as well since otherwise e.g. `X::Array{<:Rational}`
    # always uses a tolerance based on `eps(one(Float64))` even when parameters are of type
    # Float32
    return _default_rtol(float(promote_type(Base.promote_typeof(params...), eltype(X))))
end

# We use less sharp tolerances for Float16 and Float32 since the proportion of significant
# digits that are equal when evaluating Rmath and StatsFuns is smaller
# eps^(7//8) means requiring equality of about 7/8 of the significant digits, etc.
_default_rtol(::Type{Float64}) = eps(Float64)^(7 // 8) # ~2.0e-14
_default_rtol(::Type{Float32}) = eps(Float32)^(3 // 4) # ~6.4e-6
_default_rtol(::Type{Float16}) = eps(Float16)^(2 // 3) # ~9.9e-3

using StatsFuns, Test
using ChainRulesCore
using ChainRulesTestUtils
using Random

@testset "chainrules" begin
    x = exp(randn())
    y = exp(randn())
    z = logistic(randn())
    test_frule(betalogpdf, x, y, z)
    test_rrule(betalogpdf, x, y, z)

    x = exp(randn())
    y = exp(randn())
    z = exp(randn())
    test_frule(gammalogpdf, x, y, z)
    test_rrule(gammalogpdf, x, y, z)

    x = exp(randn())
    y = exp(randn())
    test_frule(chisqlogpdf, x, y)
    test_rrule(chisqlogpdf, x, y)

    x = exp(randn())
    y = exp(randn())
    z = exp(randn())
    test_frule(fdistlogpdf, x, y, z)
    test_rrule(fdistlogpdf, x, y, z)

    x = exp(randn())
    y = randn()
    test_frule(tdistlogpdf, x, y)
    test_rrule(tdistlogpdf, x, y)

    x = rand(1:100)
    y = logistic(randn())
    z = rand(1:x)
    test_frule(binomlogpdf, x, y, z)
    test_rrule(binomlogpdf, x, y, z)

    x = exp(randn())
    y = rand(1:100)
    test_frule(poislogpdf, x, y)
    test_rrule(poislogpdf, x, y)

    # test special case λ = 0
    _, pb = rrule(poislogpdf, 0.0, 0)
    _, x̄1, _ = pb(1)
    @test x̄1 == -1
    _, pb = rrule(poislogpdf, 0.0, 1)
    _, x̄1, _ = pb(1)
    @test x̄1 == Inf

    h = randn()
    a = randn()
    test_frule(owens_t, h, a)
    test_rrule(owens_t, h, a)
end

# functions related to noncentral T distribution

# Rmath implementations
function ntdistpdf(k::Real, λ::Real, x::Real)
    T = float(Base.promote_typeof(k, λ, x))
    return convert(T, Rmath.dnt(x, k, λ, false))
end
function ntdistlogpdf(k::Real, λ::Real, x::Real)
    T = float(Base.promote_typeof(k, λ, x))
    return convert(T, Rmath.dnt(x, k, λ, true))
end

function ntdistcdf(k::Real, λ::Real, x::Real)
    T = float(Base.promote_typeof(k, λ, x))
    return convert(T, Rmath.pnt(x, k, λ, true, false))
end
function ntdistccdf(k::Real, λ::Real, x::Real)
    T = float(Base.promote_typeof(k, λ, x))
    return convert(T, Rmath.pnt(x, k, λ, false, false))
end
function ntdistlogcdf(k::Real, λ::Real, x::Real)
    T = float(Base.promote_typeof(k, λ, x))
    return convert(T, Rmath.pnt(x, k, λ, true, true))
end
function ntdistlogccdf(k::Real, λ::Real, x::Real)
    T = float(Base.promote_typeof(k, λ, x))
    return convert(T, Rmath.pnt(x, k, λ, false, true))
end

function ntdistinvcdf(k::Real, λ::Real, q::Real)
    T = float(Base.promote_typeof(k, λ, q))
    return convert(T, Rmath.qnt(q, k, λ, true, false))
end
function ntdistinvccdf(k::Real, λ::Real, q::Real)
    T = float(Base.promote_typeof(k, λ, q))
    return convert(T, Rmath.qnt(q, k, λ, false, false))
end
function ntdistinvlogcdf(k::Real, λ::Real, lq::Real)
    T = float(Base.promote_typeof(k, λ, lq))
    return convert(T, Rmath.qnt(lq, k, λ, true, true))
end
function ntdistinvlogccdf(k::Real, λ::Real, lq::Real)
    T = float(Base.promote_typeof(k, λ, lq))
    return convert(T, Rmath.qnt(lq, k, λ, false, true))
end

# functions related to Poisson distribution

# Julia implementations
poispdf(λ::Real, x::Real) = exp(poislogpdf(λ, x))

poislogpdf(λ::Real, x::Real) = poislogpdf(promote(λ, x)...)
function poislogpdf(λ::T, x::T) where {T <: Real}
    val = xlogy(x, λ) - λ - loggamma(x + 1)
    return x >= 0 && isinteger(x) ? val : oftype(val, -Inf)
end

# Just use the Gamma definitions
poiscdf(λ::Real, x::Real) = gammaccdf(max(0, floor(x + 1)), 1, λ)

poisccdf(λ::Real, x::Real) = gammacdf(max(0, floor(x + 1)), 1, λ)

poislogcdf(λ::Real, x::Real) = gammalogccdf(max(0, floor(x + 1)), 1, λ)

poislogccdf(λ::Real, x::Real) = gammalogcdf(max(0, floor(x + 1)), 1, λ)

# Rmath implementations
function poisinvcdf(λ::Real, q::Real)
    T = float(Base.promote_typeof(λ, q))
    return convert(T, Rmath.qpois(q, λ, true, false))
end
function poisinvccdf(λ::Real, q::Real)
    T = float(Base.promote_typeof(λ, q))
    return convert(T, Rmath.qpois(q, λ, false, false))
end
function poisinvlogcdf(λ::Real, lq::Real)
    T = float(Base.promote_typeof(λ, lq))
    return convert(T, Rmath.qpois(lq, λ, true, true))
end
function poisinvlogccdf(λ::Real, lq::Real)
    T = float(Base.promote_typeof(λ, lq))
    return convert(T, Rmath.qpois(lq, λ, false, true))
end

# functions related to normal distribution

function xval(μ::Real, σ::Real, z::Number)
    return if isinf(z) && iszero(σ)
        μ + one(σ) * z
    else
        μ + σ * z
    end
end
zval(μ::Real, σ::Real, x::Number) = (x - μ) / σ

# pdf
normpdf(z::Number) = exp(-abs2(z) / 2) * invsqrt2π
function normpdf(μ::Real, σ::Real, x::Number)
    if iszero(σ)
        if x == μ
            z = zval(μ, one(σ), x)
        else
            z = zval(μ, σ, x)
            σ = one(σ)
        end
    else
        z = zval(μ, σ, x)
    end
    return normpdf(z) / σ
end

# logpdf
normlogpdf(z::Number) = -(abs2(z) + log2π) / 2
function normlogpdf(μ::Real, σ::Real, x::Number)
    if iszero(σ)
        if x == μ
            z = zval(μ, one(σ), x)
        else
            z = zval(μ, σ, x)
            σ = one(σ)
        end
    else
        z = zval(μ, σ, x)
    end
    return normlogpdf(z) - log(σ)
end

# cdf
normcdf(z::Number) = erfc(-z * invsqrt2) / 2
function normcdf(μ::Real, σ::Real, x::Number)
    if iszero(σ) && x == μ
        z = zval(zero(μ), σ, one(x))
    else
        z = zval(μ, σ, x)
    end
    return normcdf(z)
end
# ccdf
normccdf(z::Number) = erfc(z * invsqrt2) / 2
function normccdf(μ::Real, σ::Real, x::Number)
    if iszero(σ) && x == μ
        z = zval(zero(μ), σ, one(x))
    else
        z = zval(μ, σ, x)
    end
    return normccdf(z)
end

# logcdf
normlogcdf(z::Number) = z < -1.0 ?
    log(erfcx(-z * invsqrt2) / 2) - abs2(z) / 2 :
    log1p(-erfc(z * invsqrt2) / 2)
function normlogcdf(μ::Real, σ::Real, x::Number)
    if iszero(σ) && x == μ
        z = zval(zero(μ), σ, one(x))
    else
        z = zval(μ, σ, x)
    end
    return normlogcdf(z)
end

# logccdf
normlogccdf(z::Number) = z > 1.0 ?
    log(erfcx(z * invsqrt2) / 2) - abs2(z) / 2 :
    log1p(-erfc(-z * invsqrt2) / 2)
function normlogccdf(μ::Real, σ::Real, x::Number)
    if iszero(σ) && x == μ
        z = zval(zero(μ), σ, one(x))
    else
        z = zval(μ, σ, x)
    end
    return normlogccdf(z)
end

norminvcdf(p::Real) = -erfcinv(2 * p) * sqrt2
# Promote to ensure that we don't compute erfcinv in low precision and then promote
norminvcdf(μ::Real, σ::Real, p::Real) = norminvcdf(promote(μ, σ, p)...)
norminvcdf(μ::T, σ::T, p::T) where {T <: Real} = xval(μ, σ, norminvcdf(p))

norminvccdf(p::Real) = erfcinv(2 * p) * sqrt2
# Promote to ensure that we don't compute erfcinv in low precision and then promote
norminvccdf(μ::Real, σ::Real, p::Real) = norminvccdf(promote(μ, σ, p)...)
norminvccdf(μ::T, σ::T, p::T) where {T <: Real} = xval(μ, σ, norminvccdf(p))

# invlogcdf. Fixme! Support more precisions than Float64
norminvlogcdf(lp::Union{Float16, Float32}) = convert(typeof(lp), _norminvlogcdf_impl(Float64(lp)))
norminvlogcdf(lp::Real) = _norminvlogcdf_impl(Float64(lp))
norminvlogcdf(μ::Real, σ::Real, lp::Real) = xval(μ, σ, norminvlogcdf(lp))

# invlogccdf. Fixme! Support more precisions than Float64
norminvlogccdf(lp::Union{Float16, Float32}) = convert(typeof(lp), -_norminvlogcdf_impl(Float64(lp)))
norminvlogccdf(lp::Real) = -_norminvlogcdf_impl(Float64(lp))
norminvlogccdf(μ::Real, σ::Real, lp::Real) = xval(μ, σ, norminvlogccdf(lp))


# norminvcdf & norminvlogcdf implementation
#
#   Rational approximations for the inverse cdf and its logarithm, from:
#
#   Wichura, M.J. (1988) Algorithm AS 241: The Percentage Points of the Normal Distribution
#   Journal of the Royal Statistical Society. Series C (Applied Statistics), Vol. 37, No. 3, pp. 477-484
#

function _norminvlogcdf_impl(lp::Float64)
    return if isfinite(lp) && lp < 0.0
        q = exp(lp) - 0.5
        # qnorm_kernel(lp, q, true)
        if abs(q) <= 0.425
            _qnorm_ker1(q)
        else
            r = sqrt(q < 0 ? -lp : -log1mexp(lp))
            return copysign(_qnorm_ker2(r), q)
        end
    elseif lp >= 0.0
        lp == 0.0 ? Inf : NaN
    else # lp is -Inf or NaN
        lp
    end
end

function _qnorm_ker1(q::Float64)
    # pre-condition: abs(q) <= 0.425
    r = 0.180625 - q * q
    return q * @horner(
        r,
        3.38713_28727_96366_6080e0,
        1.33141_66789_17843_7745e2,
        1.97159_09503_06551_4427e3,
        1.37316_93765_50946_1125e4,
        4.59219_53931_54987_1457e4,
        6.72657_70927_00870_0853e4,
        3.34305_75583_58812_8105e4,
        2.50908_09287_30122_6727e3
    ) /
        @horner(
        r,
        1.0,
        4.23133_30701_60091_1252e1,
        6.87187_00749_20579_0830e2,
        5.39419_60214_24751_1077e3,
        2.12137_94301_58659_5867e4,
        3.93078_95800_09271_0610e4,
        2.87290_85735_72194_2674e4,
        5.22649_52788_52854_5610e3
    )
end

function _qnorm_ker2(r::Float64)
    return if r < 5.0
        r -= 1.6
        @horner(
            r,
            1.42343_71107_49683_57734e0,
            4.63033_78461_56545_29590e0,
            5.76949_72214_60691_40550e0,
            3.64784_83247_63204_60504e0,
            1.27045_82524_52368_38258e0,
            2.41780_72517_74506_11770e-1,
            2.27238_44989_26918_45833e-2,
            7.74545_01427_83414_07640e-4
        ) /
            @horner(
            r,
            1.0,
            2.05319_16266_37758_82187e0,
            1.67638_48301_83803_84940e0,
            6.89767_33498_51000_04550e-1,
            1.48103_97642_74800_74590e-1,
            1.51986_66563_61645_71966e-2,
            5.47593_80849_95344_94600e-4,
            1.05075_00716_44416_84324e-9
        )
    else
        r -= 5.0
        @horner(
            r,
            6.65790_46435_01103_77720e0,
            5.46378_49111_64114_36990e0,
            1.78482_65399_17291_33580e0,
            2.96560_57182_85048_91230e-1,
            2.65321_89526_57612_30930e-2,
            1.24266_09473_88078_43860e-3,
            2.71155_55687_43487_57815e-5,
            2.01033_43992_92288_13265e-7
        ) /
            @horner(
            r,
            1.0,
            5.99832_20655_58879_37690e-1,
            1.36929_88092_27358_05310e-1,
            1.48753_61290_85061_48525e-2,
            7.86869_13114_56132_59100e-4,
            1.84631_83175_10054_68180e-5,
            1.42151_17583_16445_88870e-7,
            2.04426_31033_89939_78564e-15
        )
    end
end

# import of Rmath functions

module RFunctions

using Rmath: Rmath

### import macro

function _import_rmath(rname::Symbol, jname::Symbol, pargs)
    # Rmath function names
    dfun = Symbol(:d, rname)    # density
    pfun = Symbol(:p, rname)    # cumulative probability
    qfun = Symbol(:q, rname)    # quantile
    rfun = Symbol(:r, rname)    # random sampling

    # Julia function names
    pdf = Symbol(jname, "pdf")
    cdf = Symbol(jname, "cdf")
    ccdf = Symbol(jname, "ccdf")

    logpdf = Symbol(jname, "logpdf")
    logcdf = Symbol(jname, "logcdf")
    logccdf = Symbol(jname, "logccdf")

    invcdf = Symbol(jname, "invcdf")
    invccdf = Symbol(jname, "invccdf")
    invlogcdf = Symbol(jname, "invlogcdf")
    invlogccdf = Symbol(jname, "invlogccdf")

    rand = Symbol(jname, "rand")

    # arguments & argument types
    pdecls = [Expr(:(::), ps, :Real) for ps in pargs] # [:(p1::Real), :(p2::Real), ...]

    if rname == :tukey
        # ptukey and qtukey have an extra literal 1 argument
        pargs = (pargs..., 1)
    end

    # Function implementation
    return quote
        if $(isdefined(Rmath, dfun))
            function $pdf($(pdecls...), x::Real)
                T = float(Base.promote_typeof($(pargs...), x))
                return convert(T, Rmath.$dfun(x, $(pargs...), false))
            end

            function $logpdf($(pdecls...), x::Real)
                T = float(Base.promote_typeof($(pargs...), x))
                return convert(T, Rmath.$dfun(x, $(pargs...), true))
            end
        end

        if $(isdefined(Rmath, pfun))
            function $cdf($(pdecls...), x::Real)
                T = float(Base.promote_typeof($(pargs...), x))
                return convert(T, Rmath.$pfun(x, $(pargs...), true, false))
            end

            function $ccdf($(pdecls...), x::Real)
                T = float(Base.promote_typeof($(pargs...), x))
                return convert(T, Rmath.$pfun(x, $(pargs...), false, false))
            end

            function $logcdf($(pdecls...), x::Real)
                T = float(Base.promote_typeof($(pargs...), x))
                return convert(T, Rmath.$pfun(x, $(pargs...), true, true))
            end

            function $logccdf($(pdecls...), x::Real)
                T = float(Base.promote_typeof($(pargs...), x))
                return convert(T, Rmath.$pfun(x, $(pargs...), false, true))
            end
        end

        if $(isdefined(Rmath, qfun))
            function $invcdf($(pdecls...), q::Real)
                T = float(Base.promote_typeof($(pargs...), q))
                return convert(T, Rmath.$qfun(q, $(pargs...), true, false))
            end

            function $invccdf($(pdecls...), q::Real)
                T = float(Base.promote_typeof($(pargs...), q))
                return convert(T, Rmath.$qfun(q, $(pargs...), false, false))
            end

            function $invlogcdf($(pdecls...), lq::Real)
                T = float(Base.promote_typeof($(pargs...), lq))
                return convert(T, Rmath.$qfun(lq, $(pargs...), true, true))
            end

            function $invlogccdf($(pdecls...), lq::Real)
                T = float(Base.promote_typeof($(pargs...), lq))
                return convert(T, Rmath.$qfun(lq, $(pargs...), false, true))
            end
        end

        if $(isdefined(Rmath, rfun))
            $rand($(pdecls...)) = Rmath.$rfun($(pargs...))
        end
    end
end

macro import_rmath(rname, jname, pargs...)
    return esc(_import_rmath(rname, jname, pargs))
end

### Import specific functions

@import_rmath signrank signrank n
@import_rmath beta beta α β
@import_rmath binom binom n p
@import_rmath chisq chisq k
@import_rmath f fdist ν1 ν2
@import_rmath gamma gamma k θ
@import_rmath hyper hyper ms mf n
@import_rmath norm norm μ σ
@import_rmath nbinom nbinom r p
@import_rmath pois pois λ
@import_rmath t tdist k
@import_rmath tukey srdist k ν
@import_rmath wilcox wilcox nx ny

@import_rmath nbeta nbeta α β λ
@import_rmath nchisq nchisq k λ
@import_rmath nf nfdist k1 k2 λ
@import_rmath nt ntdist k λ

end

# functions related to gamma distribution

using HypergeometricFunctions: _₁F₁

# Julia implementations
gammapdf(k::Real, θ::Real, x::Real) = exp(gammalogpdf(k, θ, x))

gammalogpdf(k::Real, θ::Real, x::Real) = gammalogpdf(promote(k, θ, x)...)
function gammalogpdf(k::T, θ::T, x::T) where {T <: Real}
    # we ensure that `log(x)` does not error if `x < 0`
    xθ = max(x, 0) / θ
    val = -loggamma(k) - log(θ) - xθ
    # xlogy(k - 1, xθ) - xθ -> -∞ for xθ -> ∞ so we only add the first term
    # when it's safe
    if isfinite(xθ)
        val += xlogy(k - 1, xθ)
    end
    return x < 0 ? oftype(val, -Inf) : val
end

function gammacdf(k::T, θ::T, x::T) where {T <: Real}
    # Handle the degenerate case
    if iszero(k)
        return float(last(promote(x, x >= 0)))
    end
    return first(gamma_inc(k, max(0, x) / θ))
end
gammacdf(k::Real, θ::Real, x::Real) = gammacdf(map(float, promote(k, θ, x))...)

function gammaccdf(k::T, θ::T, x::T) where {T <: Real}
    # Handle the degenerate case
    if iszero(k)
        return float(last(promote(x, x < 0)))
    end
    return last(gamma_inc(k, max(0, x) / θ))
end
gammaccdf(k::Real, θ::Real, x::Real) = gammaccdf(map(float, promote(k, θ, x))...)

gammalogcdf(k::Real, θ::Real, x::Real) = _gammalogcdf(map(float, promote(k, θ, x))...)

# Implemented via the non-log version. For tiny values, we recompute the result with
# loggamma. In that situation, there is little risk of significant cancellation.
function _gammalogcdf(k::Float64, θ::Float64, x::Float64)
    # Handle the degenerate case
    if iszero(k)
        return log(x >= 0)
    end

    xdθ = max(0, x) / θ
    l, u = gamma_inc(k, xdθ)
    if l < floatmin(Float64) && isfinite(k) && isfinite(xdθ)
        return -log(k) + k * log(xdθ) - xdθ + log(_₁F₁(1.0, 1 + k, xdθ)) - loggamma(k)
    elseif l < 0.7
        return log(l)
    else
        return log1p(-u)
    end
end
function _gammalogcdf(k::T, θ::T, x::T) where {T <: Union{Float16, Float32}}
    return T(_gammalogcdf(Float64(k), Float64(θ), Float64(x)))
end

gammalogccdf(k::Real, θ::Real, x::Real) = _gammalogccdf(map(float, promote(k, θ, x))...)

# Implemented via the non-log version. For tiny values, we recompute the result with
# loggamma. In that situation, there is little risk of significant cancellation.
function _gammalogccdf(k::Float64, θ::Float64, x::Float64)
    # Handle the degenerate case
    if iszero(k)
        return log(x < 0)
    end

    xdθ = max(0, x) / θ
    l, u = gamma_inc(k, xdθ)
    if u < floatmin(Float64)
        return loggamma(k, xdθ) - loggamma(k)
    elseif u < 0.7
        return log(u)
    else
        return log1p(-l)
    end
end

function _gammalogccdf(k::T, θ::T, x::T) where {T <: Union{Float16, Float32}}
    return T(_gammalogccdf(Float64(k), Float64(θ), Float64(x)))
end

function gammainvcdf(k::Real, θ::Real, p::Real)
    _k, _θ, _p = promote(k, θ, p)
    return _θ * gamma_inc_inv(_k, _p, 1 - _p)
end

function gammainvccdf(k::Real, θ::Real, p::Real)
    _k, _θ, _p = promote(k, θ, p)
    return _θ * gamma_inc_inv(_k, 1 - _p, _p)
end

# Rmath implementations
function gammainvlogcdf(k::Real, θ::Real, lq::Real)
    T = float(Base.promote_typeof(k, θ, lq))
    return convert(T, Rmath.qgamma(lq, k, θ, true, true))
end
function gammainvlogccdf(k::Real, θ::Real, lq::Real)
    T = float(Base.promote_typeof(k, θ, lq))
    return convert(T, Rmath.qgamma(lq, k, θ, false, true))
end

# functions related to noncentral F distribution

# Rmath implementations
function nfdistpdf(k1::Real, k2::Real, λ::Real, x::Real)
    T = float(Base.promote_typeof(k1, k2, λ, x))
    return convert(T, Rmath.dnf(x, k1, k2, λ, false))
end
function nfdistlogpdf(k1::Real, k2::Real, λ::Real, x::Real)
    T = float(Base.promote_typeof(k1, k2, λ, x))
    return convert(T, Rmath.dnf(x, k1, k2, λ, true))
end

function nfdistcdf(k1::Real, k2::Real, λ::Real, x::Real)
    T = float(Base.promote_typeof(k1, k2, λ, x))
    return convert(T, Rmath.pnf(x, k1, k2, λ, true, false))
end
function nfdistccdf(k1::Real, k2::Real, λ::Real, x::Real)
    T = float(Base.promote_typeof(k1, k2, λ, x))
    return convert(T, Rmath.pnf(x, k1, k2, λ, false, false))
end
function nfdistlogcdf(k1::Real, k2::Real, λ::Real, x::Real)
    T = float(Base.promote_typeof(k1, k2, λ, x))
    return convert(T, Rmath.pnf(x, k1, k2, λ, true, true))
end
function nfdistlogccdf(k1::Real, k2::Real, λ::Real, x::Real)
    T = float(Base.promote_typeof(k1, k2, λ, x))
    return convert(T, Rmath.pnf(x, k1, k2, λ, false, true))
end

function nfdistinvcdf(k1::Real, k2::Real, λ::Real, q::Real)
    T = float(Base.promote_typeof(k1, k2, λ, q))
    return convert(T, Rmath.qnf(q, k1, k2, λ, true, false))
end
function nfdistinvccdf(k1::Real, k2::Real, λ::Real, q::Real)
    T = float(Base.promote_typeof(k1, k2, λ, q))
    return convert(T, Rmath.qnf(q, k1, k2, λ, false, false))
end
function nfdistinvlogcdf(k1::Real, k2::Real, λ::Real, lq::Real)
    T = float(Base.promote_typeof(k1, k2, λ, lq))
    return convert(T, Rmath.qnf(lq, k1, k2, λ, true, true))
end
function nfdistinvlogccdf(k1::Real, k2::Real, λ::Real, lq::Real)
    T = float(Base.promote_typeof(k1, k2, λ, lq))
    return convert(T, Rmath.qnf(lq, k1, k2, λ, false, true))
end

#=
Compute the number of sequences of `nx` 0s and `ny` 1s in each of which a 1 precedes a 0 `U` times.

## Details

Due to symmetry, we only have to consider the case `nx ≤ ny`.
Let `m = min(nx, ny)` and `n = max(nx, ny)`, and denote the number of sequences of `m` 0s and `n` 1s
in which a 1 precedes a 0 `U` times by `pₘ,ₙ(U)`.

Mann and Whitney (1947) computed `pₘ,ₙ(U)` by exploiting the recurrence relation

pₘ,ₙ(U) = pₘ₋₁,ₙ(U - n) + pₘ,ₙ₋₁(U)

It can be obtained by considering the sequence with the last element removed:
1. If the last element is a 0, it is preceded by `n` 1s;
   and hence in the sequence with the last element removed, consisting of `m - 1` 0s and `n` 1s, a 1 must precede a 0 `U - n` times.
2. If the last element is a 1, it does not precede any 0;
   and hence in the sequence with the last element removed, consisting of `m` 0s and `n - 1` 1s, a 1 must preced a 0 `U` times.

Löffler (1983) published the recurrence relation

pₘ,ₙ(U) = 1/U \sum_{a = 0}^{U - 1} σₘ,ₙ(U - a) pₘ,ₙ(a)

where

σₘ,ₙ(k) := \sum_{d | k} ϵₘ,ₙ(d) d

with ϵₘ,ₙ(d) = 1 for 1 ≤ d ≤ m, ϵₘ,ₙ(d) = -1 for n < d ≤ m + n, and ϵₘ,ₙ(d) = 0 otherwise.
Implementation of this recurrence relation allows faster computations with fewer memory allocations.

## References

H. B. Mann, D. R. Whitney. "On a Test of Whether one of Two Random Variables is Stochastically Larger than the Other." Ann. Math. Statist. 18 (1) 50 - 60, March, 1947. https://doi.org/10.1214/aoms/1177730491 
A. Löffler: "Über eine Partition der nat. Zahlen und ihre Anwendung beim U-Test." Wissenschaftliche Zeitschrift der Martin-Luther-Universität Halle-Wittenberg; Mathematisch-Naturwissenschaftliche Reihe, XXXII'83 M, Heft 5, 87–89; available as https://upload.wikimedia.org/wikipedia/commons/f/f5/LoefflerWilcoxonMannWhitneyTest.pdf
=#

#=
The recurrence below is linear and homogeneous in `pₘ,ₙ`, so seeding it with
`1 / binomial(nx + ny, nx)` instead of `1` yields the probabilities directly.
This matters because the counts themselves grow like `binomial(nx + ny, nx)` and overflow
`Int` from `nx + ny = 68` onwards, whereas the probabilities are bounded by 1.
=#
function wilcox_probabilities(nx::Int, ny::Int, U::Int)
    # This internal function expects 0 <= U <= nx * ny / 2
    if !(0 <= U <= (nx * ny) / 2)
        throw(ArgumentError("`wilcox_probabilities(nx, ny, U)` is only implemented for 0 <= U <= (nx * ny) / 2"))
    end

    # Due to symmetry, `wilcox_probabilities(nx, ny, U) = wilcox_probabilities(ny, nx, U)`
    # Hence for simplicity we only consider the case `wilcox_probabilities(min(nx, ny), max(nx, ny), U)` here
    m, n = minmax(nx, ny)

    # Compute σ(k) = ∑_{d|k} ϵ(d) d where
    # - ϵ(d) := 1 for 1 ≤ d ≤ m
    # - ϵ(d) := -1 for n < d ≤ m + n
    # - ϵ(d) := 0 otherwise
    sigmas = zeros(Int, U)
    for d in 1:m
        for i in d:d:U
            sigmas[i] += d
        end
    end
    for d in (n + 1):(m + n)
        for i in d:d:U
            sigmas[i] -= d
        end
    end

    # Recursively compute pₘ,ₙ(a) / binomial(nx + ny, nx) for 0 <= a <= U, in units of
    # 2^shift. The logarithm of the coefficient is used since `binomial(nx + ny, nx)` itself
    # overflows `Int` from `nx + ny = 68` onwards.
    #
    # The seed is the probability of the least likely outcome, so it leaves the normal range
    # long before the probabilities of interest do: it is subnormal from `nx + ny = 1030` and
    # zero from `nx + ny = 1090`, and since the recurrence is homogeneous a seed of zero
    # would silently zero every probability. Working in units of 2^shift avoids that. The
    # recurrence is homogeneous so the choice of unit cannot affect the result, `ldexp`
    # removes it from the scalar result exactly, and `shift` is zero whenever the seed is
    # normal.
    logbinom = first(logabsbinomial(nx + ny, nx))
    shift = max(0, ceil(Int, (logbinom - 700) / logtwo))
    probabilities = Vector{Float64}(undef, U + 1)
    probabilities[1] = exp(shift * logtwo - logbinom)
    for a in 1:U
        p = 0.0
        for i in 1:a
            p += probabilities[i] * sigmas[a + 1 - i]
        end
        probabilities[a + 1] = p / a
    end

    return probabilities, shift
end

function wilcoxpdf(nx::Int, ny::Int, U::Float64)
    return isinteger(U) ? wilcoxpdf(nx, ny, Int(U)) : 0.0
end
function wilcoxpdf(nx::Int, ny::Int, U::Int)
    max_U = nx * ny
    if !(0 <= U <= max_U)
        return 0.0
    end
    U = min(U, max_U - U)
    probabilities, shift = wilcox_probabilities(nx, ny, U)
    return ldexp(probabilities[end], -shift)
end

function wilcoxlogpdf(nx::Int, ny::Int, U::Union{Float64, Int})
    return log(wilcoxpdf(nx, ny, U))
end

function wilcoxcdf(nx::Int, ny::Int, U::Float64)
    return wilcoxcdf(nx, ny, round(Int, U, RoundNearestTiesUp))
end
function wilcoxcdf(nx::Int, ny::Int, U::Int)
    max_U = nx * ny
    if U < 0
        return 0.0
    elseif U >= max_U
        return 1.0
    else
        U2 = max_U - U - 1
        probabilities, shift = wilcox_probabilities(nx, ny, min(U, U2))
        p = ldexp(sum(probabilities), -shift)
        return U2 < U ? 1.0 - p : p
    end
end

function wilcoxlogcdf(nx::Int, ny::Int, U::Union{Float64, Int})
    max_U = nx * ny
    U2 = max_U - U - 1
    if U2 < U
        return log1p(-wilcoxcdf(nx, ny, U2))
    else
        return log(wilcoxcdf(nx, ny, U))
    end
end

function wilcoxccdf(nx::Int, ny::Int, U::Float64)
    return wilcoxccdf(nx, ny, round(Int, U, RoundNearestTiesUp))
end
function wilcoxccdf(nx::Int, ny::Int, U::Int)
    max_U = nx * ny
    return wilcoxcdf(nx, ny, max_U - U - 1)
end

function wilcoxlogccdf(nx::Int, ny::Int, U::Union{Float64, Int})
    max_U = nx * ny
    U2 = max_U - U - 1
    if U2 < U + 2 # +2 is empirical
        return log(wilcoxccdf(nx, ny, U))
    else
        return log1p(-wilcoxccdf(nx, ny, U2))
    end
    return
end

function wilcoxinvcdf(nx::Int, ny::Int, p::Float64)
    if !(0.0 <= p <= 1.0)
        return NaN
    end
    U = 0
    while wilcoxcdf(nx, ny, U) < p # TODO binary search and symmetry
        U += 1
    end
    return float(U)
end

function wilcoxinvlogcdf(nx::Int, ny::Int, logp::Float64)
    if !(-Inf < logp <= 0.0)
        return NaN
    end
    U = 0
    while wilcoxlogcdf(nx, ny, U) < logp # TODO binary search and symmetry
        U += 1
    end
    return float(U)
end

function wilcoxinvccdf(nx::Int, ny::Int, p::Float64)
    if !(0.0 <= p <= 1)
        return NaN
    end
    if p == 0.0
        max_U = nx * ny
        return float(max_U)
    end
    U = 0
    while wilcoxccdf(nx, ny, U) > p # TODO binary search and symmetry
        U += 1
    end
    return float(U)
end

function wilcoxinvlogccdf(nx::Int, ny::Int, logp::Float64)
    if !(-Inf < logp <= 0.0)
        return NaN
    end
    U = 0
    while wilcoxlogccdf(nx, ny, U) > logp # TODO binary search and symmetry
        U += 1
    end
    return float(U)
end

#=
The signrank distribution is equivalent to the problem
of finding the number of subsets of {1,2,...,n} summing to W,
relative to the total number of subsets.
The empty subset is defined to sum to zero.
This can be calculated using the recursion:
either n is in the subset in which case we need to calculate
the number of subsets of {1,2,...,n-1} summing to W-n,
or n is not in the subset in which case we need to calculate
the number of subsets of {1,2,...,n-1} summing to W.
This can be calculated bottom up using dynamic programming.

The i'th element of DP in the j'th outer loop iteration represents:
the probability that a subset of {1,2,...,j} sums to W-i+1,
i.e. the number of such subsets divided by the 2^j subsets in total.

The counts themselves grow like 2^n and overflow `Int` well before the
distribution stops being of interest, so the recursion is normalised as it goes
rather than divided by 2^n at the end. Halving is exact in binary floating
point, so while every count stays below 2^53 this gives exactly the counts
divided by 2^n; beyond that the additions round, but the entries stay in [0,1]
and can never overflow.
 =#

function signrankDP(n, W)
    DP = zeros(Float64, W + 1)
    DP[W + 1] = 1.0
    for j in 1:n
        for i in 1:(W + 1 - j)
            DP[i] = (DP[i] + DP[i + j]) / 2
        end
        # Sums smaller than j cannot contain j, so their counts are unchanged and
        # the corresponding probabilities only pick up the factor 1/2
        for i in max(1, W + 2 - j):(W + 1)
            DP[i] /= 2
        end
    end
    return DP
end

function signrankpdf(n::Int, W::Float64)
    return isinteger(W) ? signrankpdf(n, Int(W)) : 0.0
end
function signrankpdf(n::Int, W::Int)
    if W < 0
        return 0.0
    end
    max_W = (n * (n + 1)) >> 1
    W2 = max_W - W
    if W2 < W
        return signrankpdf(n, W2)
    end
    DP = signrankDP(n, W)
    return DP[1]
end

function signranklogpdf(n::Int, W::Union{Float64, Int})
    return log(signrankpdf(n, W))
end

function signrankcdf(n::Int, W::Float64)
    return signrankcdf(n, round(Int, W, RoundNearestTiesUp))
end
function signrankcdf(n::Int, W::Int)
    if W < 0
        return 0.0
    end
    max_W = (n * (n + 1)) >> 1
    W2 = max_W - W - 1
    if W2 < W
        return 1.0 - signrankcdf(n, W2)
    end
    DP = signrankDP(n, W)
    return sum(DP)
end

function signranklogcdf(n::Int, W::Union{Float64, Int})
    return log(signrankcdf(n, W))
end

function signrankccdf(n::Int, W::Float64)
    return signrankccdf(n, round(Int, W, RoundNearestTiesUp))
end
function signrankccdf(n::Int, W::Int)
    max_W = (n * (n + 1)) >> 1
    return signrankcdf(n, max_W - W - 1)
end

function signranklogccdf(n::Int, W::Union{Float64, Int})
    return log(signrankccdf(n, W))
end

function signrankinvcdf(n::Int, p::Float64)
    if !(0.0 <= p <= 1.0)
        return NaN
    end
    W = 0
    while signrankcdf(n, W) < p # TODO binary search and symmetry
        W += 1
    end
    return float(W)
end

function signrankinvlogcdf(n::Int, logp::Float64)
    if !(-Inf < logp <= 0.0)
        return NaN
    end
    W = 0
    while signranklogcdf(n, W) < logp # TODO binary search and symmetry
        W += 1
    end
    return float(W)
end

function signrankinvccdf(n::Int, p::Float64)
    if !(0.0 <= p <= 1)
        return NaN
    end
    if p == 0.0
        max_W = (n * (n + 1)) >> 1
        return float(max_W)
    end
    W = 0
    while signrankccdf(n, W) > p # TODO binary search and symmetry
        W += 1
    end
    return float(W)
end

function signrankinvlogccdf(n::Int, logp::Float64)
    if !(-Inf < logp <= 0.0)
        return NaN
    end
    W = 0
    while signranklogccdf(n, W) > logp # TODO binary search and symmetry
        W += 1
    end
    return float(W)
end

using StatsFuns
using Test
using InverseFunctions

@testset "inverse" begin
    x = 0.7
    InverseFunctions.test_inverse(norminvcdf, x)
    InverseFunctions.test_inverse(norminvccdf, x)
    InverseFunctions.test_inverse(norminvlogcdf, log(x))
    InverseFunctions.test_inverse(norminvlogccdf, log(x))
end

using SpecialFunctions, StatsFuns
using Test

@testset "logmvgamma" begin
    @testset "type behavior" for eltya in (Float32, Float64)
        p = rand(1:50)
        a = rand(eltya)
        # add p since loggamma is only define for positive arguments
        @test typeof(logmvgamma(p, a + p)) == eltya
    end

    @testset "consistent with loggamma" for eltya in (Float32, Float64)
        #  Γ₁(a) = Γ(a), Γ₂(a) = √π Γ(a) Γ(a - 0.5), etc
        a = rand(eltya) + 1 # add one since loggamma is only define for positive arguments
        @test logmvgamma(1, a) ≈ loggamma(a)
        @test logmvgamma(2, a) ≈ eltya(0.5logπ) + loggamma(a) + loggamma(a - eltya(0.5))
        @test logmvgamma(3, a) ≈ eltya((3 / 2) * logπ) + loggamma(a) + loggamma(a - eltya(0.5)) + loggamma(a - one(a))
    end

    @testset "consistent with itself" for eltya in (Float32, Float64)
        #  Γᵢ(a) = (π^{i-1/2}) Γ(a) Γᵢ₋₁(a - 0.5)
        for p in 1:50
            a = rand(eltya) + p # add p since loggamma is only define for positive arguments
            @test logmvgamma(p, a) ≈ eltya((p / 2 - 1 / 2) * logπ) + loggamma(a) + logmvgamma(p - 1, a - eltya(0.5))
        end
    end
end

@testset "logmvbeta" begin
    @testset "symmetry" for eltya in (Float32, Float64)
        for eltyb in (Float32, Float64)
            #  Bᵢ(a, b) = Bᵢ(b, a)
            for p in 1:50
                a = rand(eltya) + p
                b = rand(eltyb) + p
                @test logmvbeta(p, a, b) ≈ logmvbeta(p, b, a)
            end
        end
    end

    @testset "consistent with logbeta" for eltya in (Float32, Float64)
        for eltyb in (Float32, Float64)
            #  B₁(a, b) = B(a, b)
            a = rand(eltya)
            b = rand(eltyb)
            @test logmvbeta(1, a, b) ≈ logbeta(a, b)
        end
    end

    @testset "type promotion behaves" for eltya in (Float32, Float64)
        for eltyb in (Float32, Float64)
            a = rand(eltya)
            b = rand(eltyb)
            T = Base.promote_type(eltya, eltyb)
            @test typeof(logmvbeta(1, a, b)) == T
        end
    end
end

# https://github.com/JuliaStats/StatsFuns.jl/issues/115
@testset "support of binomial distribution" begin
    @test iszero(binompdf(1, 0.5, prevfloat(1.0)))
    @test iszero(binompdf(1, 0.5, nextfloat(1.0)))
    @test binomlogpdf(1, 0.5, prevfloat(1.0)) == -Inf
    @test binomlogpdf(1, 0.5, nextfloat(1.0)) == -Inf
end

@testset "binom special cases" begin
    for (n, p, k) in ((5, 0.0, 0), (5, 1.0, 5))
        @test iszero(binomlogpdf(n, p, k))
        @test isone(binompdf(n, p, k))
    end
end

@testset "lstirling_asym" begin
    # can test for equality here because the lhs is the way the value is created
    @test Float32(lstirling_asym(1.0)) == @inferred lstirling_asym(1.0f0)
    # for 64.0f0 the expansion is used but for 64.0 the BigFloat value is rounded
    @test Float32(lstirling_asym(64.0)) ≈ @inferred lstirling_asym(64.0f0)
end

# https://github.com/JuliaStats/StatsFuns.jl/issues/143
# https://github.com/JuliaMath/HypergeometricFunctions.jl/issues/47
@testset "betalogcdf: numerical issue" begin
    # Mathematica: N[Log[CDF[BetaDistribution[6041, 2496], 1/10]], 10]
    @test betalogcdf(6041, 2496, 0.1) ≈ -9020.029401
    @test betainvlogcdf(6041, 2496, betalogcdf(6041, 2496, 0.1)) ≈ 0.1
end

# https://github.com/JuliaStats/StatsFuns.jl/issues/150
@testset "gammalogcdf: numerical issue" begin
    @test gammalogcdf(42648.50647826826, 2.2498007956420723e-5, 0.6991377135675367) ≈ -1933.269895904061741
end

# https://github.com/JuliaStats/StatsFuns.jl/issues/154
@testset "tvdistinvcdf: numerical issue" begin
    @test isnan(@inferred(tdistinvcdf(0, 0.975)))
end

# Written in Julia by Andreas Noack Jensen
# January 2013
#
# Translation of Fortran file tvpack.f authored by
#
# Alan Genz
# Department of Mathematics
# Washington State University
# Pullman, WA 99164-3113
# Email : alangenz@wsu.edu
#
# Original source available from
# http://www.math.wsu.edu/faculty/genz/software/fort77/tvpack.f

function tvtcdf(nu::Int, h::Vector{Float64}, r::Vector{Float64})
    pt = 0.5 * pi
    h1 = h[1]
    h2 = h[2]
    h3 = h[3]
    r12 = r[1]
    r13 = r[2]
    r23 = r[3]

    # Sort R's and check for special cases

    if abs(r12) > abs(r13)
        h2 = h3
        h3 = h[2]
        r12 = r13
        r13 = r[1]
    end
    if abs(r13) > abs(r23)
        h1 = h2
        h2 = h[1]
        r23 = r13
        r13 = r[3]
    end
    tvt = 0.0
    if abs(h1) + abs(h2) + abs(h3) < eps()
        tvt = (1.0 + (asin(r12) + asin(r13) + asin(r23)) / pt) * 0.125
    elseif nu < 1 && abs(r12) + abs(r13) < eps()
        tvt = normcdf(h1) * bvtcdf(nu, h2, h3, r23)
    elseif nu < 1 && abs(r13) + abs(r23) < eps()
        tvt = normcdf(h3) * bvtcdf(nu, h1, h2, r12)
    elseif nu < 1 && abs(r12) + abs(r23) < eps()
        tvt = normcdf(h2) * bvtcdf(nu, h1, h3, r13)
    elseif 1.0 - r23 < eps()
        tvt = bvtcdf(nu, h1, min(h2, h3), r12)
    elseif r23 + 1.0 < eps()
        if h2 > -h3
            tvt = bvtcdf(nu, h1, h2, r12) - bvtcdf(nu, h1, -h3, r12)
        end
    else

        # Compute singular TVT value

        if nu < 1
            tvt = bvtcdf(nu, h2, h3, r23) * normcdf(h1)
        elseif r23 > 0
            tvt = bvtcdf(nu, h1, min(h2, h3), 0.0)
        elseif h2 > -h3
            tvt = bvtcdf(nu, h1, h2, 0.0) - bvtcdf(nu, h1, -h3, 0.0)
        end
        # Use numerical integration to compute probability

        rua = asin(r12)
        rub = asin(r13)
        ar = asin(r23)
        ruc = pt * sign(ar) - ar
        tvt += adonet(x -> tvtmfn(x, rua, rub, nu, h1, h2, h3, r23, ar, ruc), 0.0, 1.0, sqrt(eps())) / (4.0 * pt)
    end
    return max(0.0, min(tvt, 1.0))
end

#Computes Plackett formula integrands
function tvtmfn(x::Float64, rua::Float64, rub::Float64, nu::Int, h1::Float64, h2::Float64, h3::Float64, r23::Float64, ar::Float64, ruc::Float64)
    retval = 0.0
    r12, rr2 = sincs(rua * x)
    r13, rr3 = sincs(rub * x)
    if abs(rua) > 0
        retval += rua * pntgnd(nu, h1, h2, h3, r13, r23, r12, rr2)
    end
    if abs(rub) > 0
        retval += rub * pntgnd(nu, h1, h3, h2, r12, r23, r13, rr3)
    end
    if nu > 0
        r, rr = sincs(ar + ruc * x)
        retval -= ruc * pntgnd(nu, h2, h3, h1, 0.0, 0.0, r, rr)
    end
    return retval
end

# Computes SIN(X), COS(X)^2, with series approx. for |X| near PI/2
function sincs(x::Float64)
    ee = (0.5 * pi - abs(x))^2
    if ee < 5.0e-5
        sx = abs(1.0 - ee * (1.0 - ee / 12.0) * 0.5) * sign(x)
        cs = ee * (1.0 - ee * (1.0 - 2.0 * ee / 15.0) / 3.0)
    else
        sx = sin(x)
        cs = 1.0 - sx * sx
    end
    return sx, cs
end

# Computes Plackett formula integrand
function pntgnd(nu::Int, ba::Float64, bb::Float64, bc::Float64, ra::Float64, rb::Float64, r::Float64, rr::Float64)
    retval = 0.0
    dt = rr * (rr - (ra - rb)^2 - 2.0 * ra * rb * (1.0 - r))
    if dt > 0
        bt = (bc * rr + ba * (r * rb - ra) + bb * (r * ra - rb)) / sqrt(dt)
        ft = (ba - r * bb)^2 / rr + bb * bb
        if nu < 1
            if bt > -10 && ft < 100
                retval = exp(-ft * 0.5)
                if bt < 10
                    retval *= normcdf(bt)
                end
            end
        else
            ft = sqrt(1.0 + ft / nu)
            retval = tcdf(nu, bt / ft) / ft^nu
        end
    end
    return retval
end

# # One Dimensional Globally Adaptive Integration Function

function adonet(f::Function, a::Float64, b::Float64, tol::Float64)
    ai = Vector{Float64}(100)
    bi = Vector{Float64}(100)
    ei = Vector{Float64}(100)
    fi = Vector{Float64}(100)
    ai[1] = a
    bi[1] = b
    err = 1.0
    ip = 1
    im = 1
    fin = 0.0
    while 4.0err > tol && im < 100
        im += 1
        bi[im] = bi[ip]
        ai[im] = (ai[ip] + bi[ip]) * 0.5
        bi[ip] = ai[im]
        fi[ip], ei[ip] = krnrdt(ai[ip], bi[ip], f)
        fi[im], ei[im] = krnrdt(ai[im], bi[im], f)
        err = 0.0
        fin = 0.0
        for i in 1:im
            if ei[i] > ei[ip]
                ip = i
            end
            fin += fi[i]
            err += ei[i]^2
        end
        err = sqrt(err)
    end
    return fin
end

# # Kronrod Rule

const kronrod_wg = [
    0.2729250867779007e+0,
    0.5566856711617449e-1,
    0.1255803694649048e+0,
    0.1862902109277352e+0,
    0.2331937645919914e+0,
    0.2628045445102478e+0,
]

const kronrod_xgk = [
    0.0e+0,
    0.9963696138895427e+0,
    0.978228658146057e+0,
    0.9416771085780681e+0,
    0.8870625997680953e+0,
    0.8160574566562211e+0,
    0.7301520055740492e+0,
    0.6305995201619651e+0,
    0.5190961292068118e+0,
    0.3979441409523776e+0,
    0.269543155952345e+0,
    0.1361130007993617e+0,
]

const kronrod_wgk = [
    0.1365777947111183e+0,
    0.976544104596129e-2,
    0.2715655468210443e-1,
    0.4582937856442671e-1,
    0.6309742475037484e-1,
    0.7866457193222764e-1,
    0.9295309859690074e-1,
    0.1058720744813894e+0,
    0.1167395024610472e+0,
    0.1251587991003195e+0,
    0.1312806842298057e+0,
    0.1351935727998845e+0,
]

function krnrdt(a::Float64, b::Float64, f::Function)
    wid = (b - a) * 0.5
    cen = (b + a) * 0.5
    fc = f(cen)
    resg = fc * kronrod_wg[1]
    resk = fc * kronrod_wgk[1]
    for j in 1:11
        t = wid * kronrod_xgk[j + 1]
        fc = f(cen - t) + f(cen + t)
        resk += kronrod_wgk[j + 1] * fc
        if mod(j, 2) == 0
            resg += kronrod_wg[div(j, 2) + 1] * fc
        end
    end
    retval = wid * resk
    err = abs(wid * (resk - resg))
    return retval, err
end

# # Student t Distribution Function

function tcdf(nu::Int, t::Float64)
    if nu < 1
        studnt = normcdf(t)
    elseif nu == 1
        studnt = (1.0 + 2.0atan(t) / pi) * 0.5
    elseif nu == 2
        studnt = (1.0 + t / sqrt(2.0 + t * t)) * 0.5
    else
        tt = t * t
        cssthe = 1.0 / (1.0 + tt / nu)
        polyn = 1.0
        for j in (nu - 2):-2:2
            polyn = 1.0 + (j - 1) * cssthe * polyn / j
        end
        if mod(nu, 2) == 1
            rn = nu
            ts = t / sqrt(rn)
            studnt = (1.0 + 2.0 * (atan(ts) + ts * cssthe * polyn) / pi) * 0.5
        else
            snthe = t / sqrt(nu + tt)
            studnt = (1.0 + snthe * polyn) * 0.5
        end
        studnt = max(0.0, min(studnt, 1.0))
    end
    return studnt
end

function bvtcdf(nu::Int, dh::Float64, dk::Float64, r::Float64)
    if nu < 1
        return bvnuppercdf(-dh, -dk, r)
    elseif 1.0 - r < eps()
        return tcdf(nu, min(dh, dk))
    elseif r + 1.0 < eps()
        if dh > -dk
            return tcdf(nu, dh) - tcdf(nu, -dk)
        else
            return 0.0
        end
    else
        snu = sqrt(nu)
        ors = 1.0 - r * r
        hrk = dh - r * dk
        krh = dk - r * dh
        if abs(hrk) + ors > 0
            xnhk = hrk^2 / (hrk^2 + ors * (nu + dk^2))
            xnkh = krh^2 / (krh^2 + ors * (nu + dh^2))
        else
            xnhk = 0.0
            xnkh = 0.0
        end
        hs = sign(hrk)
        ks = sign(krh)
        if mod(nu, 2) == 0
            bvt = atan(sqrt(ors), -r) / (2.0pi)
            gmph = dh / sqrt(16.0 * (nu + dh^2))
            gmpk = dk / sqrt(16.0 * (nu + dk^2))
            btnckh = 2.0atan(sqrt(xnkh), sqrt(1.0 - xnkh)) / pi
            btpdkh = 2.0sqrt(xnkh * (1.0 - xnkh)) / pi
            btnchk = 2.0atan(sqrt(xnhk), sqrt(1.0 - xnhk)) / pi
            btpdhk = 2.0sqrt(xnhk * (1.0 - xnhk)) / pi
            for j in 1:div(nu, 2)
                bvt += gmph * (1.0 + ks * btnckh)
                bvt += gmpk * (1.0 + hs * btnchk)
                btnckh += btpdkh
                btpdkh *= 2.0j * (1.0 - xnkh) / (2j + 1)
                btnchk += btpdhk
                btpdhk *= 2.0j * (1.0 - xnhk) / (2j + 1)
                gmph *= (2j - 1) / (2j * (1.0 + dh * dh / nu))
                gmpk *= (2j - 1) / (2j * (1.0 + dk * dk / nu))
            end
        else
            qhrk = sqrt(dh * dh + dk * dk - 2.0r * dh * dk + nu * ors)
            hkrn = dh * dk + r * nu
            hkn = dh * dk - nu
            hpk = dh + dk
            bvt = atan(-snu * (hkn * qhrk + hpk * hkrn), hkn * hkrn - nu * hpk * qhrk) / (2.0pi)
            if bvt < -eps()
                bvt += 1.0
            end
            gmph = dh / (2.0pi * snu * (1.0 + dh * dh / nu))
            gmpk = dk / (2.0pi * snu * (1.0 + dk * dk / nu))
            btnckh = sqrt(xnkh)
            btpdkh = btnckh
            btnchk = sqrt(xnhk)
            btpdhk = btnchk
            for j in 1:div(nu - 1, 2)
                bvt += gmph * (1.0 + ks * btnckh)
                bvt += gmpk * (1.0 + hs * btnchk)
                btpdkh *= (2j - 1) * (1.0 - xnkh) / (2 * j)
                btnckh += btpdkh
                btpdhk *= (2j - 1) * (1.0 - xnhk) / (2 * j)
                btnchk += btpdhk
                gmph *= 2.0j / ((2j + 1) * (1.0 + dh * dh / nu))
                gmpk *= 2.0j / ((2j + 1) * (1.0 + dk * dk / nu))
            end
        end
        return bvt
    end
end

# This function is based on the method described by
#     Drezner, Z and G.O. Wesolowsky, (1989),
#     On the computation of the bivariate normal integral,
#     Journal of Statist. Comput. Simul. 35, pp. 101-107,
# with major modifications for double precision, and for |R| close to 1.

const bvncdf_w_array = [
    0.1713244923791705e+0 0.4717533638651177e-1 0.1761400713915212e-1;
    0.3607615730481384e+0 0.1069393259953183e+0 0.4060142980038694e-1;
    0.4679139345726904e+0 0.1600783285433464e+0 0.6267204833410906e-1;
    0.0                    0.2031674267230659e+0 0.8327674157670475e-1;
    0.0                       0.2334925365383547e+0 0.1019301198172404e+0;
    0.0                       0.2491470458134029e+0 0.1181945319615184e+0;
    0.0                       0.0                      0.1316886384491766e+0;
    0.0                       0.0                      0.1420961093183821e+0;
    0.0                       0.0                      0.1491729864726037e+0;
    0.0                       0.0                      0.1527533871307259e+0
]

const bvncdf_x_array = [
    -0.9324695142031522e+0 -0.9815606342467191e+0 -0.9931285991850949e+0;
    -0.6612093864662647e+0 -0.904117256370475e+0 -0.9639719272779138e+0;
    -0.238619186083197e+0 -0.769902674194305e+0 -0.9122344282513259e+0;
    0.0                     -0.5873179542866171e+0 -0.8391169718222188e+0;
    0.0                     -0.3678314989981802e+0 -0.7463319064601508e+0;
    0.0                     -0.1252334085114692e+0 -0.636053680726515e+0;
    0.0                     0.0                     -0.5108670019508271e+0;
    0.0                     0.0                     -0.3737060887154196e+0;
    0.0                     0.0                     -0.2277858511416451e+0;
    0.0                     0.0                     -0.7652652113349733e-1
]

function bvnuppercdf(dh::T, dk::T, r::T)::T where {T <: Float64}

    if r < -one(T) || r > one(T)
        throw(DomainError("r must be ∈ [-1,1]"))
    end

    if isfinite(dh) && isfinite(dk)
        if abs(r) < 0.3
            ng = 1
            lg = 3
        elseif abs(r) < 0.75
            ng = 2
            lg = 6
        else
            ng = 3
            lg = 10
        end
        h = dh
        k = dk
        hk = h * k
        bvn = 0.0
        if abs(r) < 0.925
            if abs(r) > 0
                hs = (h * h + k * k) * 0.5
                asr = asin(r)
                for i in 1:lg
                    for j in -1:2:1
                        sn = sin(asr * (j * bvncdf_x_array[i, ng] + 1.0) * 0.5)
                        bvn += bvncdf_w_array[i, ng] * exp((sn * hk - hs) / (1.0 - sn * sn))
                    end
                end
                bvn *= asr / (4.0pi)
            end
            bvn += normcdf(-h) * normcdf(-k)
        else
            if r < 0
                k = -k
                hk = -hk
            end
            if abs(r) < 1
                as = (1.0 - r) * (1.0 + r)
                a = sqrt(as)
                bs = (h - k)^2
                c = (4.0 - hk) * 0.125
                d = (12.0 - hk) * 0.0625
                asr = -(bs / as + hk) * 0.5
                if asr > -100
                    bvn = a * exp(asr) * (1.0 - c * (bs - as) * (1.0 - d * bs / 5.0) / 3.0 + c * d * as * as / 5.0)
                end
                if -hk < 100
                    b = sqrt(bs)
                    bvn -= exp(-hk * 0.5) * sqrt(2.0pi) * normcdf(-b / a) * b * (1.0 - c * bs * (1.0 - d * bs / 5.0) / 3.0)
                end
                a /= 2.0
                for i in 1:lg
                    for j in -1:2:1
                        xs = (a * (j * bvncdf_x_array[i, ng] + 1.0))^2
                        rs = sqrt(1.0 - xs)
                        asr = -(bs / xs + hk) * 0.5
                        if asr > -100
                            bvn += a * bvncdf_w_array[i, ng] * exp(asr) * (exp(-hk * (1.0 - rs) / (2.0 * (1.0 + rs))) / rs - (1.0 + c * xs * (1.0 + d * xs)))
                        end
                    end
                end
                bvn /= -2.0pi
            end
            if r > 0
                bvn += normcdf(-max(h, k))
            else
                bvn = -bvn
                if k > h
                    bvn += normcdf(k) - normcdf(h)
                end
            end
        end
        return bvn

        # here we either have 0 or the marginal
    else
        if dh == typemax(T) || dk == typemax(T)
            return zero(T)
        elseif dh == typemin(T)
            return normcdf(-dk)
        elseif dk == typemin(T)
            return normcdf(-dh)
        else
            throw(error())
        end
    end
end

bvncdf(dh, dk, r) = bvnuppercdf(-dh, -dk, r)

# functions related to student's T distribution

tdistpdf(ν::Real, x::Real) = exp(tdistlogpdf(ν, x))

tdistlogpdf(ν::Real, x::Real) = tdistlogpdf(promote(ν, x)...)
function tdistlogpdf(ν::T, x::T) where {T <: Real}
    isinf(ν) && return normlogpdf(x)
    νp12 = (ν + 1) / 2
    return loggamma(νp12) - (logπ + log(ν)) / 2 - loggamma(ν / 2) - νp12 * log1p(x^2 / ν)
end

function tdistcdf(ν::T, x::T) where {T <: Real}
    if isinf(ν)
        return normcdf(x)
    elseif x < 0
        return fdistccdf(one(ν), ν, x^2) / 2
    else
        return 1 - fdistccdf(one(ν), ν, x^2) / 2
    end
end
tdistcdf(ν::Real, x::Real) = tdistcdf(map(float, promote(ν, x))...)

tdistccdf(ν::Real, x::Real) = tdistcdf(ν, -x)

function tdistlogcdf(ν::T, x::T) where {T <: Real}
    if isinf(ν)
        return normlogcdf(x)
    elseif x < 0
        ret = fdistlogccdf(one(ν), ν, x^2)
        return ret - logtwo
    else
        return log1p(-fdistccdf(one(ν), ν, x^2) / 2)
    end
end
tdistlogcdf(ν::Real, x::Real) = tdistlogcdf(map(float, promote(ν, x))...)

tdistlogccdf(ν::Real, x::Real) = tdistlogcdf(ν, -x)

function tdistinvcdf(ν::T, p::T) where {T <: Real}
    if isinf(ν)
        return norminvcdf(p)
    elseif p < 0.5
        return -sqrt(fdistinvccdf(one(ν), ν, 2 * p))
    else
        return sqrt(fdistinvccdf(one(ν), ν, 2 * (1 - p)))
    end
end
tdistinvcdf(ν::Real, p::Real) = tdistinvcdf(map(float, promote(ν, p))...)

tdistinvccdf(ν::Real, p::Real) = -tdistinvcdf(ν, p)
function tdistinvlogcdf(ν::T, logp::T) where {T <: Real}
    if isinf(ν)
        return norminvlogcdf(logp)
    else
        logq = logp + logtwo
        if logq < 0
            return -sqrt(fdistinvlogccdf(one(ν), ν, logq))
        else
            return sqrt(fdistinvlogccdf(one(ν), ν, log2mexp(logq)))
        end
    end
end
tdistinvlogcdf(ν::Real, logp::Real) = tdistinvlogcdf(map(float, promote(ν, logp))...)

tdistinvlogccdf(ν::Real, logp::Real) = -tdistinvlogcdf(ν, logp)

# functions related to noncentral chi-square distribution

# Rmath implementations
function nchisqpdf(k::Real, λ::Real, x::Real)
    T = float(Base.promote_typeof(k, λ, x))
    return convert(T, Rmath.dnchisq(x, k, λ, false))
end
function nchisqlogpdf(k::Real, λ::Real, x::Real)
    T = float(Base.promote_typeof(k, λ, x))
    return convert(T, Rmath.dnchisq(x, k, λ, true))
end

function nchisqcdf(k::Real, λ::Real, x::Real)
    T = float(Base.promote_typeof(k, λ, x))
    return convert(T, Rmath.pnchisq(x, k, λ, true, false))
end
function nchisqccdf(k::Real, λ::Real, x::Real)
    T = float(Base.promote_typeof(k, λ, x))
    return convert(T, Rmath.pnchisq(x, k, λ, false, false))
end
function nchisqlogcdf(k::Real, λ::Real, x::Real)
    T = float(Base.promote_typeof(k, λ, x))
    return convert(T, Rmath.pnchisq(x, k, λ, true, true))
end
function nchisqlogccdf(k::Real, λ::Real, x::Real)
    T = float(Base.promote_typeof(k, λ, x))
    return convert(T, Rmath.pnchisq(x, k, λ, false, true))
end

function nchisqinvcdf(k::Real, λ::Real, q::Real)
    T = float(Base.promote_typeof(k, λ, q))
    return convert(T, Rmath.qnchisq(q, k, λ, true, false))
end
function nchisqinvccdf(k::Real, λ::Real, q::Real)
    T = float(Base.promote_typeof(k, λ, q))
    return convert(T, Rmath.qnchisq(q, k, λ, false, false))
end
function nchisqinvlogcdf(k::Real, λ::Real, lq::Real)
    T = float(Base.promote_typeof(k, λ, lq))
    return convert(T, Rmath.qnchisq(lq, k, λ, true, true))
end
function nchisqinvlogccdf(k::Real, λ::Real, lq::Real)
    T = float(Base.promote_typeof(k, λ, lq))
    return convert(T, Rmath.qnchisq(lq, k, λ, false, true))
end

# functions related to F distribution

# Julia implementations
fdistpdf(ν1::Real, ν2::Real, x::Real) = exp(fdistlogpdf(ν1, ν2, x))

fdistlogpdf(ν1::Real, ν2::Real, x::Real) = fdistlogpdf(promote(ν1, ν2, x)...)
function fdistlogpdf(ν1::T, ν2::T, x::T) where {T <: Real}
    # we ensure that `log(x)` does not error if `x < 0`
    ν1ν2 = ν1 / ν2
    y = max(x, 0)
    val = (xlogy(ν1, ν1ν2) + xlogy(ν1 - 2, y) - xlogy(ν1 + ν2, 1 + ν1ν2 * y)) / 2 - logbeta(ν1 / 2, ν2 / 2)
    return x < 0 ? oftype(val, -Inf) : val
end

for f in ("cdf", "ccdf", "logcdf", "logccdf")
    ff = Symbol("fdist" * f)
    bf = Symbol("beta" * f)
    @eval $ff(ν1::T, ν2::T, x::T) where {T <: Real} = $bf(ν1 / 2, ν2 / 2, inv(1 + ν2 / (ν1 * max(0, x))))
    @eval $ff(ν1::Real, ν2::Real, x::Real) = $ff(promote(ν1, ν2, x)...)
end
for f in ("invcdf", "invccdf", "invlogcdf", "invlogccdf")
    ff = Symbol("fdist" * f)
    bf = Symbol("beta" * f)
    @eval function $ff(ν1::T, ν2::T, y::T) where {T <: Real}
        x = $bf(ν1 / 2, ν2 / 2, y)
        return x / (1 - x) * ν2 / ν1
    end
    @eval $ff(ν1::Real, ν2::Real, y::Real) = $ff(promote(ν1, ν2, y)...)
end

# functions related to noncentral beta distribution

# Rmath implementations
function nbetapdf(α::Real, β::Real, λ::Real, x::Real)
    T = float(Base.promote_typeof(α, β, λ, x))
    return convert(T, Rmath.dnbeta(x, α, β, λ, false))
end
function nbetalogpdf(α::Real, β::Real, λ::Real, x::Real)
    T = float(Base.promote_typeof(α, β, λ, x))
    return convert(T, Rmath.dnbeta(x, α, β, λ, true))
end

function nbetacdf(α::Real, β::Real, λ::Real, x::Real)
    T = float(Base.promote_typeof(α, β, λ, x))
    return convert(T, Rmath.pnbeta(x, α, β, λ, true, false))
end
function nbetaccdf(α::Real, β::Real, λ::Real, x::Real)
    T = float(Base.promote_typeof(α, β, λ, x))
    return convert(T, Rmath.pnbeta(x, α, β, λ, false, false))
end
function nbetalogcdf(α::Real, β::Real, λ::Real, x::Real)
    T = float(Base.promote_typeof(α, β, λ, x))
    return convert(T, Rmath.pnbeta(x, α, β, λ, true, true))
end
function nbetalogccdf(α::Real, β::Real, λ::Real, x::Real)
    T = float(Base.promote_typeof(α, β, λ, x))
    return convert(T, Rmath.pnbeta(x, α, β, λ, false, true))
end

function nbetainvcdf(α::Real, β::Real, λ::Real, q::Real)
    T = float(Base.promote_typeof(α, β, λ, q))
    return convert(T, Rmath.qnbeta(q, α, β, λ, true, false))
end
function nbetainvccdf(α::Real, β::Real, λ::Real, q::Real)
    T = float(Base.promote_typeof(α, β, λ, q))
    return convert(T, Rmath.qnbeta(q, α, β, λ, false, false))
end
function nbetainvlogcdf(α::Real, β::Real, λ::Real, lq::Real)
    T = float(Base.promote_typeof(α, β, λ, lq))
    return convert(T, Rmath.qnbeta(lq, α, β, λ, true, true))
end
function nbetainvlogccdf(α::Real, β::Real, λ::Real, lq::Real)
    T = float(Base.promote_typeof(α, β, λ, lq))
    return convert(T, Rmath.qnbeta(lq, α, β, λ, false, true))
end

# functions related to studentized range distribution

# Rmath implementations
# The `1` argument is `nranges` (number of ranges) which `Rmath.ptukey`/`qtukey`
# default to `1.0` in `kwargs` but is positional in the Julia wrapper. Without
# it the `lower_tail`/`log_p` Bool flags shift into the `nranges` slot.
function srdistcdf(k::Real, ν::Real, x::Real)
    T = float(Base.promote_typeof(k, ν, x))
    return convert(T, Rmath.ptukey(x, k, ν, 1, true, false))
end
function srdistccdf(k::Real, ν::Real, x::Real)
    T = float(Base.promote_typeof(k, ν, x))
    return convert(T, Rmath.ptukey(x, k, ν, 1, false, false))
end
function srdistlogcdf(k::Real, ν::Real, x::Real)
    T = float(Base.promote_typeof(k, ν, x))
    return convert(T, Rmath.ptukey(x, k, ν, 1, true, true))
end
function srdistlogccdf(k::Real, ν::Real, x::Real)
    T = float(Base.promote_typeof(k, ν, x))
    return convert(T, Rmath.ptukey(x, k, ν, 1, false, true))
end

function srdistinvcdf(k::Real, ν::Real, q::Real)
    T = float(Base.promote_typeof(k, ν, q))
    return convert(T, Rmath.qtukey(q, k, ν, 1, true, false))
end
function srdistinvccdf(k::Real, ν::Real, q::Real)
    T = float(Base.promote_typeof(k, ν, q))
    return convert(T, Rmath.qtukey(q, k, ν, 1, false, false))
end
function srdistinvlogcdf(k::Real, ν::Real, lq::Real)
    T = float(Base.promote_typeof(k, ν, lq))
    return convert(T, Rmath.qtukey(lq, k, ν, 1, true, true))
end
function srdistinvlogccdf(k::Real, ν::Real, lq::Real)
    T = float(Base.promote_typeof(k, ν, lq))
    return convert(T, Rmath.qtukey(lq, k, ν, 1, false, true))
end

using StatsFuns
using Aqua: Aqua
using ExplicitImports: ExplicitImports
using JET: JET
using Test

@testset "QA" begin
    @testset "Aqua" begin
        Aqua.test_all(StatsFuns)
    end

    @testset "ExplicitImports" begin
        # No implicit imports (`using XY`)
        @test ExplicitImports.check_no_implicit_imports(StatsFuns) === nothing

        # All explicit imports (`using XY: Z`) are loaded via their owners
        @test ExplicitImports.check_all_explicit_imports_via_owners(
            StatsFuns;
            ignore = (
                # Ref https://github.com/JuliaTesting/ExplicitImports.jl/issues/92
                :digamma,
            ),
        ) === nothing

        # Limit explicit imports (`using XY: Z`) of non-public names to a minimum
        @test ExplicitImports.check_all_explicit_imports_are_public(
            StatsFuns;
            ignore = (
                # Ref https://github.com/JuliaTesting/ExplicitImports.jl/issues/92
                :digamma,
            ),
        ) === nothing

        # No explicit imports (`using XY: Z`) that are not used
        @test ExplicitImports.check_no_stale_explicit_imports(StatsFuns; ignore = (:digamma,)) === nothing

        # Nothing is accessed via modules other than its owner
        @test ExplicitImports.check_all_qualified_accesses_via_owners(StatsFuns) === nothing

        # Limit accesses of non-public names to a minimum
        @test ExplicitImports.check_all_qualified_accesses_are_public(
            StatsFuns;
            ignore = (
                (VERSION < v"1.11" ? (:Fix2,) : ())...,
                :promote_typeof,
            ),
        ) === nothing

        # No self-qualified accesses
        @test ExplicitImports.check_no_self_qualified_accesses(StatsFuns) === nothing
    end

    @testset "JET" begin
        # Check that there are no undefined global references and undefined field accesses
        JET.test_package(StatsFuns; target_modules = (StatsFuns,), mode = :typo)

        # Analyze methods based on their declared signature
        JET.report_package(StatsFuns; target_modules = (StatsFuns,))
    end
end

# Miscellaneous functions

"""
    logmvgamma(p::Int, a::Real)

Return the logarithm of [multivariate gamma function](https://en.wikipedia.org/wiki/Multivariate_gamma_function) ([DLMF 35.3.1](https://dlmf.nist.gov/35.3.1)).
"""
function logmvgamma(p::Int, a::Real)
    # NOTE: one(a) factors are here to prevent unnecessary promotion of Float32
    res = p * (p - 1) * (logπ * one(a)) / 4
    for ii in 1:p
        res += loggamma(a + (1 - ii) * one(a) / 2)
    end
    return res
end

"""
    logmvbeta(p::Int, a::Real, b::Real)

Return the logarithm of the multivariate beta function ([DLMF 35.3.7](https://dlmf.nist.gov/35.3#E7)).
"""
logmvbeta(p::Int, a::T, b::T) where {T <: Real} = logmvgamma(p, a) + logmvgamma(p, b) - logmvgamma(p, a + b)
logmvbeta(p::Int, a::Real, b::Real) = logmvbeta(p, promote(a, b)...)

"""
    lstirling_asym(x)

The remainder term after
[Stirling's approximation](https://en.wikipedia.org/wiki/Stirling%27s_approximation)
to [`loggamma`](@ref):

```math
\\log \\Gamma(x) \\approx x \\log(x) - x + \\log(2\\pi/x)/2 = \\log(x)*(x-1/2) + \\log(2\\pi)/2 - x
```

In Julia syntax, this means:

    lstirling_asym(x) = loggamma(x) + x - (x-0.5)*log(x) - 0.5*log(2π)

For sufficiently large `x`, this can be approximated using the asymptotic
_Stirling's series_ ([DLMF 5.11.1](https://dlmf.nist.gov/5.11.1)):

```math
\\frac{1}{12x} - \\frac{1}{360x^3} + \\frac{1}{1260x^5} - \\frac{1}{1680x^7} + \\ldots
```

The truncation error is bounded by the first omitted term, and is of the same sign.

Relative error of approximation is bounded by
    (174611/125400 x^-19) / (1/12 x^-1 - 1/360 x^-3)
which is < 1/2 ulp for x >= 10.0, and total numeric error appears to be < 2 ulps

# References

* Temme, N. (1996) Special functions: An introduction to the classical functions of
   mathematical physics, Wiley, New York, ISBN: 0-471-11313-1, Chapter 3.6, pp 61-65.
* Weisstein, Eric W. ["Stirling's Series."](http://mathworld.wolfram.com/StirlingsSeries.html).
  MathWorld.
* [OEIS A046968](http://oeis.org/A046968) and [OEIS A046969](http://oeis.org/A046969)
  for the series coefficients
"""
function lstirling_asym end

lstirling_asym(x::BigFloat) = loggamma(x) + x - log(x) * (x - big(0.5)) - log2π / big(2)

lstirling_asym(x::Integer) = lstirling_asym(float(x))

const lstirlingF64 = Float64[lstirling_asym(k) for k in big(1):big(64)]
const lstirlingF32 = [Float32(lstirlingF64[i]) for i in 1:40]

function lstirling_asym(x::Float64)
    isinteger(x) && (0 < x ≤ length(lstirlingF64)) && return lstirlingF64[Int(x)]
    t = inv(abs2(x))
    return @horner(
        t,
        8.33333333333333333e-2, #  1/12 x^-1
        -2.77777777777777778e-3, # -1/360 x^-3
        7.93650793650793651e-4, #  1/1260 x^-5
        -5.95238095238095238e-4, # -1/1680 x^-7
        8.41750841750841751e-4, #  1/1188 x^-9
        -1.91752691752691753e-3, # -691/360360 x^-11
        6.41025641025641026e-3, #  1/156 x^-13
        -2.95506535947712418e-2, # -3617/122400 x^-15
        1.79644372368830573e-1
    ) / x #  43867/244188 x^-17
end

function lstirling_asym(x::Float32)
    isinteger(x) && (0 < x ≤ length(lstirlingF32)) && return lstirlingF32[Int(x)]
    t = inv(abs2(x))
    return @horner(
        t,
        8.333333333333f-2, #  1/12 x^-1
        -2.777777777777f-3, # -1/360 x^-3
        7.936507936508f-4, #  1/1260 x^-5
        -5.952380952381f-4, # -1/1680 x^-7
        8.417508417508f-4
    ) / x #  1/1188 x^-9
end

# functions related to negative binomial distribution
# Implementation (log) pdf and cdfs and their inverses for the negative binomial distribution.
#
# Notation:
# - r > 0 is the number of successes until the experiment is stopped (generalized to real)
# - p ∈ [0,1] is the probability of a success (real)
# - k ≥ 0 is the number of failures (integer)
#
# The probability mass function is (k + r - 1 \choose k) p^r (1-p)^k

nbinompdf(r::Real, p::Real, k::Real) = exp(nbinomlogpdf(r, p, k))

nbinomlogpdf(r::Real, p::Real, k::Real) = nbinomlogpdf(promote(r, p, k)...)
function nbinomlogpdf(r::T, p::T, k::T) where {T <: Real}
    if !(0 <= p <= 1) || r <= 0
        return float(T)(NaN)
    elseif k >= 0 && isinteger(k)
        z = xlog1py(k, -p) + xlogy(r, p)
        iszero(k) && return z
        res = z - (logbeta(k + 1, r) + log(r + k))
        if !isnan(res)
            return res
        else
            return float(T)(-Inf)
        end
    else
        return float(T)(isnan(k) ? NaN : -Inf)
    end
end
function nbinomcdf(r::Real, p::Real, k::Real)
    if k < 0
        return zero(float(first(promote(r, p, k))))
    elseif isinf(k)
        return one(float(first(promote(r, p, k))))
    else
        return beta_inc(r, floor(k + 1), p)[1]
    end
end
function nbinomccdf(r::Real, p::Real, k::Real)
    if k < 0
        return one(float(first(promote(r, p, k))))
    elseif isinf(k)
        return zero(float(first(promote(r, p, k))))
    else
        return beta_inc(r, floor(k + 1), p)[2]
    end
end
function nbinomlogcdf(r::Real, p::Real, k::Real)
    if k < 0
        return oftype(float(first(promote(r, p, k))), -Inf)
    elseif isinf(k)
        return zero(float(first(promote(r, p, k))))
    else
        b1, b2 = beta_inc(r, floor(k + 1), p)
        return 10 * b1 < 7 ? log1p(-b2) : log(b1)
    end
end
function nbinomlogccdf(r::Real, p::Real, k::Real)
    if k < 0
        return zero(float(first(promote(r, p, k))))
    elseif isinf(k)
        return oftype(float(first(promote(r, p, k))), -Inf)
    else
        b1, b2 = beta_inc(r, floor(k + 1), p)
        return 10 * b1 < 7 ? log1p(-b1) : log(b2)
    end
end

# Rmath implementations
# TODO: implement https://arxiv.org/abs/2001.03953
# for inverting the incomplete beta function wrt the 2nd argument.
function nbinominvcdf(r::Real, p::Real, q::Real)
    T = float(Base.promote_typeof(r, p, q))
    return convert(T, Rmath.qnbinom(q, r, p, true, false))
end
function nbinominvccdf(r::Real, p::Real, q::Real)
    T = float(Base.promote_typeof(r, p, q))
    return convert(T, Rmath.qnbinom(q, r, p, false, false))
end
function nbinominvlogcdf(r::Real, p::Real, lq::Real)
    T = float(Base.promote_typeof(r, p, lq))
    return convert(T, Rmath.qnbinom(lq, r, p, true, true))
end
function nbinominvlogccdf(r::Real, p::Real, lq::Real)
    T = float(Base.promote_typeof(r, p, lq))
    return convert(T, Rmath.qnbinom(lq, r, p, false, true))
end

# functions related to binomial distribution

# Julia implementations
binompdf(n::Real, p::Real, k::Real) = exp(binomlogpdf(n, p, k))

binomlogpdf(n::Real, p::Real, k::Real) = binomlogpdf(promote(n, p, k)...)
function binomlogpdf(n::T, p::T, k::T) where {T <: Real}
    m = clamp(k, 0, n)
    val = min(0, betalogpdf(m + 1, n - m + 1, p) - log(n + 1))
    return 0 <= k <= n && isinteger(k) ? val : oftype(val, -Inf)
end

for l in ("", "log"), compl in (false, true)
    fbinom = Symbol(string("binom", l, ifelse(compl, "c", ""), "cdf"))
    fbeta = Symbol(string("beta", l, ifelse(compl, "", "c"), "cdf"))
    @eval function ($fbinom)(n::Real, p::Real, k::Real)
        if isnan(k)
            return last(promote(n, p, k))
        end
        res = ($fbeta)(max(0, floor(k) + 1), max(0, n - floor(k)), p)

        # When p == 1 the betaccdf doesn't return the correct result
        # so these cases have to be special cased
        if isone(p)
            newres = oftype(res, $compl ? k < n : k >= n)
            return $(l === "" ? :newres : :(log(newres)))
        else
            return res
        end
    end
end

# Rmath implementations
function binominvcdf(n::Real, p::Real, q::Real)
    T = float(Base.promote_typeof(n, p, q))
    return convert(T, Rmath.qbinom(q, n, p, true, false))
end
function binominvccdf(n::Real, p::Real, q::Real)
    T = float(Base.promote_typeof(n, p, q))
    return convert(T, Rmath.qbinom(q, n, p, false, false))
end
function binominvlogcdf(n::Real, p::Real, lq::Real)
    T = float(Base.promote_typeof(n, p, lq))
    return convert(T, Rmath.qbinom(lq, n, p, true, true))
end
function binominvlogccdf(n::Real, p::Real, lq::Real)
    T = float(Base.promote_typeof(n, p, lq))
    return convert(T, Rmath.qbinom(lq, n, p, false, true))
end

using StatsFuns
using Rmath: Rmath
using Test

include("utils.jl")

function check_rmath(statsfun, rmathfun, params, a, isprob, rtol)
    v = @inferred(statsfun(params..., a))
    rv = @inferred(rmathfun(a, params...))
    @test v isa float(Base.promote_typeof(params..., a))
    return if isprob
        @test v ≈ oftype(v, rv) rtol = rtol nans = true
    else
        @test v ≈ oftype(v, rv) atol = rtol rtol = rtol nans = true
    end
end

function rmathcomp(basename::String, params, X::AbstractArray, rtol = _default_rtol(params, X))
    rbasename = if basename == "nfdist"
        "nf"
    elseif basename == "ntdist"
        "nt"
    elseif basename == "srdist"
        "tukey"
    else
        basename
    end

    # Rmath.ptukey / Rmath.qtukey take an extra `nranges` positional argument
    # (defaulting to 1.0) between the distribution parameters and the
    # `lower_tail`/`log_p` flags. Inject it explicitly for tukey so the test
    # lambdas line up with the Rmath C signature.
    extra_rmath_args = rbasename == "tukey" ? (1,) : ()

    if isdefined(Rmath, Symbol(:d, rbasename))
        stats_pdf = getproperty(@__MODULE__, Symbol(basename, :pdf))
        rmath_pdf = let f = getproperty(Rmath, Symbol(:d, rbasename))
            (a, params...) -> f(a, params..., false)
        end
        @testset "pdf with x=$x" for x in X
            check_rmath(
                stats_pdf, rmath_pdf,
                params, x, true, rtol
            )
        end

        stats_logpdf = getproperty(@__MODULE__, Symbol(basename, :logpdf))
        rmath_logpdf = let f = getproperty(Rmath, Symbol(:d, rbasename))
            (a, params...) -> f(a, params..., true)
        end
        @testset "logpdf with x=$x" for x in X
            check_rmath(
                stats_logpdf, rmath_logpdf,
                params, x, false, rtol
            )
        end
    end

    if isdefined(Rmath, Symbol(:p, rbasename))
        stats_cdf = getproperty(@__MODULE__, Symbol(basename, :cdf))
        rmath_cdf = let f = getproperty(Rmath, Symbol(:p, rbasename)), extra = extra_rmath_args
            (a, params...) -> f(a, params..., extra..., true, false)
        end
        @testset "cdf with x=$x" for x in X
            check_rmath(stats_cdf, rmath_cdf, params, x, true, rtol)
        end

        stats_ccdf = getproperty(@__MODULE__, Symbol(basename, :ccdf))
        rmath_ccdf = let f = getproperty(Rmath, Symbol(:p, rbasename)), extra = extra_rmath_args
            (a, params...) -> f(a, params..., extra..., false, false)
        end
        @testset "ccdf with x=$x" for x in X
            check_rmath(stats_ccdf, rmath_ccdf, params, x, true, rtol)
        end

        stats_logcdf = getproperty(@__MODULE__, Symbol(basename, :logcdf))
        rmath_logcdf = let f = getproperty(Rmath, Symbol(:p, rbasename)), extra = extra_rmath_args
            (a, params...) -> f(a, params..., extra..., true, true)
        end
        @testset "logcdf with x=$x" for x in X
            check_rmath(stats_logcdf, rmath_logcdf, params, x, false, rtol)
        end

        stats_logccdf = getproperty(@__MODULE__, Symbol(basename, :logccdf))
        rmath_logccdf = let f = getproperty(Rmath, Symbol(:p, rbasename)), extra = extra_rmath_args
            (a, params...) -> f(a, params..., extra..., false, true)
        end
        @testset "logccdf with x=$x" for x in X
            check_rmath(stats_logccdf, rmath_logccdf, params, x, false, rtol)
        end

        #=
        signrank and wilcox are implemented natively rather than by delegating to Rmath, so
        their inverse functions are not expected to reproduce the Rmath quantile functions
        bit for bit. The inverses locate a discontinuity by searching for the first argument
        at which the cdf reaches `q`, and the `q` tested here are themselves cdf values, so
        the comparison is decided by the last bit of the cdf and is not stable across
        platforms. R's own signrank already varies this way:
        julia> psignrank(18,10,false,true) # windows
        -0.2076393647782445
        julia> psignrank(18,10,false,true) # linux
        -0.20763936477824452
        As for the other natively implemented discrete distributions, the inverse functions
        are instead tested by round tripping through our own cdf further down.
        =#
        test_inv = basename != "signrank" && basename != "wilcox"
        if isdefined(Rmath, Symbol(:q, rbasename)) && test_inv
            stats_invcdf = getproperty(@__MODULE__, Symbol(basename, :invcdf))
            rmath_invcdf = let f = getproperty(Rmath, Symbol(:q, rbasename)), extra = extra_rmath_args
                (a, params...) -> f(a, params..., extra..., true, false)
            end
            p = rmath_cdf.(X, params...)
            @testset "invcdf with q=$_p" for _p in p
                check_rmath(stats_invcdf, rmath_invcdf, params, _p, false, rtol)
            end

            stats_invccdf = getproperty(@__MODULE__, Symbol(basename, :invccdf))
            rmath_invccdf = let f = getproperty(Rmath, Symbol(:q, rbasename)), extra = extra_rmath_args
                (a, params...) -> f(a, params..., extra..., false, false)
            end
            cp = rmath_ccdf.(X, params...)
            @testset "invccdf with q=$_p" for _p in cp
                check_rmath(stats_invccdf, rmath_invccdf, params, _p, false, rtol)
            end

            stats_invlogcdf = getproperty(@__MODULE__, Symbol(basename, :invlogcdf))
            rmath_invlogcdf = let f = getproperty(Rmath, Symbol(:q, rbasename)), extra = extra_rmath_args
                (a, params...) -> f(a, params..., extra..., true, true)
            end
            lp = rmath_logcdf.(X, params...)
            @testset "invlogcdf with log(q)=$_p" for _p in lp
                check_rmath(stats_invlogcdf, rmath_invlogcdf, params, _p, false, rtol)
            end

            stats_invlogccdf = getproperty(@__MODULE__, Symbol(basename, :invlogccdf))
            rmath_invlogccdf = let f = getproperty(Rmath, Symbol(:q, rbasename)), extra = extra_rmath_args
                (a, params...) -> f(a, params..., extra..., false, true)
            end
            lcp = rmath_logccdf.(X, params...)
            @testset "invlogccdf with log(q)=$_p" for _p in lcp
                check_rmath(stats_invlogccdf, rmath_invlogccdf, params, _p, false, rtol)
            end
        end
    end

    return nothing
end

function rmathcomp_tests(basename::String, configs)
    return @testset "$basename" begin
        @testset "params: $params" for (params, data) in configs
            rmathcomp(basename, params, data)
        end
    end
end

### Test cases

@testset "RMath" begin
    rmathcomp_tests(
        "beta", [
            ((0.1, 1.0), 0.0:0.01:1.0),
            ((1.0, 1.0), 0.0:0.01:1.0),
            ((2.0, 3.0), 0.0:0.01:1.0),
            ((10.0, 2.0), 0.0:0.01:1.0),
            ((10, 2), 0.0:0.01:1.0),
            ((1.0f0, 1.0f0), 0.0f0:0.01f0:1.0f0),
            ((1.0, 1.0), 0.0f0:0.01f0:1.0f0),
            ((Float16(1), Float16(1)), Float16(0):Float16(0.01):Float16(1)),
            ((1.0f0, 1.0f0), Float16(0):Float16(0.01):Float16(1)),
            ((10, 2), [0, 1]),
            ((10, 2), (0 // 1):(1 // 100):(1 // 1)),
        ]
    )
    # It is not possible to maintain a rtol of 1e-14 for the cdf when there is such a large difference
    # in the magnitude of the parameters. At least not with the current parameters. Furthermore, it
    # seems that Rmath is actually less accurate than we are but since we are comparing against Rmath
    # we have to use rtol=1e-12 although we are probably only off by around 1e-13.
    @testset "param: (1000, 2)" begin
        rmathcomp(
            "beta",
            (1000, 2),
            # We have to drop the 0.48 value since the R quantile function fails while we succeed.
            # It's tested separate below.
            setdiff(collect(0.0:0.01:1.0), 0.48),
            1.0e-12
        )
        # Test p=0.48 separately since R fails. (It's pretty slow, though, caused by the cdf being 9.0797754e-317)
        @test betainvcdf(1000, 2, betacdf(1000, 2, 0.48)) ≈ 0.48
    end
    @testset "$(f)(0, 0, $x) should error" for f in (betacdf, betaccdf, betalogcdf, betalogccdf),
            x in (0.0, 0.5, 1.0)
        @test_throws DomainError f(0.0, 0.0, x)
    end
    # Have to check them separately since Rmath is not completely consistent with our conventions:
    # - betacdf(α, β, x) = P(X ≤ x) where X ~ Beta(α, β)
    # - betaccdf(α, β, x) = P(X > x) where X ~ Beta(α, β)
    # - betainvcdf(α, β, p) = inf { x : p ≤ P(X ≤ x) } where X ~ Beta(α, β)
    # - betainvccdf(α, β, p) = sup { x : p ≤ P(X > x) } where X ~ Beta(α, β)
    @testset "beta: degenerate cases" begin
        # Check degenerate cases Beta(0, β) and Dirac(α, 0) with α, β > 0
        # Beta(0, β) is a Dirac distribution at x=0
        # Beta(α, 0) is a Dirac distribution at x=1
        α = β = 1 // 2

        for x in 0.0f0:0.01f0:1.0f0
            # Check betacdf
            @test @inferred(betacdf(0, β, x)) === 1.0f0
            @test @inferred(betacdf(α, 0, x)) === (x < 1 ? 0.0f0 : 1.0f0)

            # Check betaccdf, betalogcdf, and betalogccdf based on betacdf
            @test @inferred(betaccdf(0, β, x)) === 1 - betacdf(0, β, x)
            @test @inferred(betaccdf(α, 0, x)) === 1 - betacdf(α, 0, x)
            @test @inferred(betalogcdf(0, β, x)) === log(betacdf(0, β, x))
            @test @inferred(betalogcdf(α, 0, x)) === log(betacdf(α, 0, x))
            @test @inferred(betalogccdf(0, β, x)) === log(betaccdf(0, β, x))
            @test @inferred(betalogccdf(α, 0, x)) === log(betaccdf(α, 0, x))
        end

        for p in 0.0f0:0.01f0:1.0f0
            # Check betainvcdf
            @test @inferred(betainvcdf(0, β, p)) === 0.0f0
            @test @inferred(betainvcdf(α, 0, p)) === (p > 0 ? 1.0f0 : 0.0f0)

            # Check betainvccdf
            @test @inferred(betainvccdf(0, β, p)) === (p > 0 ? 0.0f0 : 1.0f0)
            @test @inferred(betainvccdf(α, 0, p)) === 1.0f0
        end
    end

    rmathcomp_tests(
        "binom", [
            ((1, 0.5), 0.0:1.0),
            ((1, 0.7), 0.0:1.0),
            ((8, 0.6), 0.0:8.0),
            ((20, 0.1), 0.0:20.0),
            ((20, 0.9), 0.0:20.0),
            ((20, 0.9), 0:20),
            ((1, 0.5f0), 0.0f0:1.0f0),
            ((1, 0.5), 0.0f0:1.0f0),
            ((1, Float16(0.5)), Float16(0):Float16(1)),
            ((1, 0.5f0), Float16(0):Float16(1)),
            ((10, 1 // 2), (0 // 1):(10 // 1)),
            ((1, 0.5), [-Inf, Inf]),
        ]
    )

    rmathcomp_tests(
        "chisq", [
            ((1,), 0.0:0.1:8.0),
            ((4,), 0.0:0.1:8.0),
            ((9,), 0.0:0.1:8.0),
            ((9,), 0:8),
            ((1,), 0.0f0:0.1f0:8.0f0),
            ((1,), Float16(0):Float16(0.1):Float16(8)),
            ((9,), (0 // 1):(8 // 1)),
            ((1), [-Inf, Inf]),
        ]
    )

    rmathcomp_tests(
        "fdist", [
            ((1, 1), (0.0:0.1:5.0)),
            ((2, 1), (0.0:0.1:5.0)),
            ((5, 2), (0.0:0.1:5.0)),
            ((10, 1), (0.0:0.1:5.0)),
            ((10, 3), (0.0:0.1:5.0)),
            ((10, 3), (0:5)),
            ((1, 1), (0.0f0:0.1f0:5.0f0)),
            ((1, 1), (Float16(0):Float16(0.1):Float16(5))),
            ((10, 3), (0 // 1):(5 // 1)),
        ]
    )

    rmathcomp_tests(
        "gamma", [
            ((1.0, 1.0), (0.0:0.05:12.0)),
            ((0.5, 1.0), (0.0:0.05:12.0)),
            ((3.0, 1.0), (0.0:0.05:12.0)),
            ((9.0, 1.0), (0.0:0.05:12.0)),
            ((2.0, 3.0), (0.0:0.05:12.0)),
            ((2, 3), (0:12)),
            ((1.0f0, 1.0f0), (0.0f0:0.05f0:12.0f0)),
            ((1.0, 1.0), (0.0f0:0.05f0:12.0f0)),
            ((Float16(1), Float16(1)), (Float16(0):Float16(0.05):Float16(12))),
            ((1.0f0, 1.0f0), (Float16(0):Float16(0.05):Float16(12))),
            ((2, 3), ((0 // 1):(12 // 1))),
            ((3.0, 1.0e-310), (0.0:0.05:12.0)),
            ((1, 1.0), [-Inf, Inf]),
        ]
    )

    rmathcomp_tests(
        "hyper", [
            ((2, 3, 4), 0.0:4.0),
            ((2, 3, 4), 0:4),
            ((2, 3, 4), 0.0f0:4.0f0),
            ((2, 3, 4), Float16(0):Float16(4)),
            ((2, 3, 4), (0 // 1):(4 // 1)),
        ]
    )

    rmathcomp_tests(
        "nbeta", [
            ((1.0, 1.0, 0.0), 0.01:0.01:0.99),
            ((2.0, 3.0, 0.0), 0.01:0.01:0.99),
            ((1.0, 1.0, 2.0), 0.01:0.01:0.99),
            ((3.0, 4.0, 2.0), 0.01:0.01:0.99),
            ((3, 4, 2), 0.01:0.01:0.99),
            ((1.0f0, 1.0f0, 0.0f0), 0.01f0:0.01f0:0.99f0),
            ((1.0, 1.0, 0.0), 0.01f0:0.01f0:0.99f0),
            ((Float16(1), Float16(1), Float16(0)), Float16(0.01):Float16(0.01):Float16(0.99)),
            ((1.0f0, 1.0f0, 0.0f0), Float16(0.01):Float16(0.01):Float16(0.99)),
            ((3, 4, 2), (1 // 100):(1 // 100):(99 // 100)),
            ((1.0, 1.0, 0.0), [-Inf, Inf]),
        ]
    )

    rmathcomp_tests(
        "nbinom", [
            ((1, 0.5), 0.0:20.0),
            ((3, 0.5), 0.0:20.0),
            ((3, 0.2), 0.0:20.0),
            ((3, 0.8), 0.0:20.0),
            ((1, 0.5f0), 0.0f0:20.0f0),
            ((1, 0.5), 0.0f0:20.0f0),
            ((1, Float16(0.5)), Float16(0):Float16(20)),
            ((3, 0.8), 0:20),
            ((3, 1 // 2), (0 // 1):(20 // 1)),
            ((1, 0.5), [-Inf, Inf, NaN]),
            ((1, 0.5f0), [-Inf32, Inf32, NaN32, -2, 1.1]),
        ]
    )

    rmathcomp_tests(
        "nchisq", [
            ((2, 1), 0.0:0.2:8.0),
            ((2, 3), 0.0:0.2:8.0),
            ((4, 1), 0.0:0.2:8.0),
            ((4, 3), 0.0:0.2:8.0),
            ((4, 3), 0:8),
            ((2, 1), 0.0f0:0.2f0:8.0f0),
            ((2, 1), Float16(0):Float16(0.2):Float16(8)),
            ((2, 1), (0 // 1):(1 // 5):(8 // 1)),
            ((2, 1), [-Inf, Inf]),
        ]
    )

    rmathcomp_tests(
        "nfdist", [
            ((1.0, 1.0, 0.0), 0.1:0.1:10.0),
            ((1.0, 1.0, 2.0), 0.1:0.1:10.0),
            ((2.0, 3.0, 1.0), 0.1:0.1:10.0),
            ((2, 3, 1), 1:10),
            ((1.0f0, 1.0f0, 0.0f0), 0.1f0:0.1f0:10.0f0),
            ((1.0, 1.0, 0.0), 0.1f0:0.1f0:10.0f0),
            ((Float16(1), Float16(1), Float16(0)), Float16(0.1):Float16(0.1):Float16(10)),
            ((1.0f0, 1.0f0, 0.0f0), Float16(0.1):Float16(0.1):Float16(10)),
            ((2, 3, 1), (1 // 1):(10 // 1)),
            ((1.0, 1.0, 0.0), [-Inf, Inf]),
        ]
    )

    rmathcomp_tests(
        "norm", [
            ((0.0, 1.0), -6.0:0.01:6.0),
            ((2.0, 1.0), -3.0:0.01:7.0),
            ((0.0, 0.5), -3.0:0.01:3.0),
            ((0, 1), -3.0:3.0),
            ((0, 1), -3.0:0.01:3.0),
            ((0, 1), -3:3),
            ((0.0, 0.0), -6.0:0.1:6.0),
            ((0.0f0, 1.0f0), -6.0f0:0.01f0:6.0f0),
            ((0.0, 1.0), -6.0f0:0.01f0:6.0f0),
            ((0, 2), (-6 // 1):(1 // 2):(6 // 1)),
            ((0.0f0, 2.0f0), (-6 // 1):(1 // 2):(6 // 1)),
            ((0.0, 1.0), [-Inf, Inf]),
            # Fail since `SpecialFunctions.erfcx` is not implemented for `Float16`
            #((Float16(0), Float16(1)), -Float16(6):Float16(0.01):Float16(6)),
            #((0f0, 1f0), -Float16(6):Float16(0.01):Float16(6)),
        ]
    )

    rmathcomp_tests(
        "ntdist", [
            ((0, 1), -4.0:0.1:10.0),
            ((0, 4), -4.0:0.1:10.0),
            ((2, 1), -4.0:0.1:10.0),
            ((2, 4), -4.0:0.1:10.0),
            ((2, 4), -4:10),
            ((0, 1), -4.0f0:0.1f0:10.0f0),
            ((0, 1), -Float16(4):Float16(0.1):Float16(10)),
            ((0, 1), (-4 // 1):(1 // 10):(10 // 1)),
            ((10, 1), [-Inf, Inf]),
        ]
    )

    rmathcomp_tests(
        "pois", [
            ((0.5,), 0.0:20.0),
            ((1.0,), 0.0:20.0),
            ((2.0,), 0.0:20.0),
            ((10.0,), 0.0:20.0),
            ((10,), 0:20),
            ((0.5f0,), 0.0f0:20.0f0),
            ((0.5,), 0.0f0:20.0f0),
            ((Float16(0.5),), Float16(0):Float16(20)),
            ((0.5f0,), Float16(0):Float16(20)),
            ((1 // 2,), (0 // 1):(20 // 1)),
        ]
    )

    rmathcomp_tests(
        "tdist", [
            ((1,), -5.0:0.1:5.0),
            ((2,), -5.0:0.1:5.0),
            ((5,), -5.0:0.1:5.0),
            ((5,), -5:5),
            ((1,), -5.0f0:0.1f0:5.0f0),
            ((1,), -Float16(5):Float16(0.1):Float16(5)),
            ((1,), (-5 // 1):(5 // 1)),
            ((Inf,), -5.0:0.1:5.0),
            ((Inf32,), -5.0f0:0.1f0:5.0f0),
            ((1,), [-Inf, Inf]),
        ]
    )

    rmathcomp_tests(
        "signrank", [
            ((4), -2:12),
            ((4), -2.0:0.25:12.0),
            ((10), -2:57),
        ]
    )

    # The R version does not roundtrip cdf->invcdf, while our version does
    @test_broken RFunctions.signrankinvcdf.(50, RFunctions.signrankcdf.(50, -1:1276)) == [0; 0:1275; 1275]
    @test signrankinvcdf.(50, signrankcdf.(50, -1:1276)) == [0; 0:1275; 1275]
    @test signrankinvccdf.(50, signrankccdf.(50, -1:1276)) == [0; 0:1275; 1275]
    @test signrankinvlogcdf.(50, signranklogcdf.(50, 0:1276)) == [0:1275; 1275]
    @test isnan(signrankinvlogcdf.(50, signranklogcdf(500, -1)))
    @test signrankinvlogccdf.(50, signranklogccdf.(50, -1:1274)) == [0; 0:1274]
    @test isnan(signrankinvlogccdf.(50, signranklogccdf.(50, 1275)))
    @test isnan(signrankinvlogccdf.(50, signranklogccdf.(50, 1276)))

    # The subset counts grow like 2^n, so accumulating them in `Int` silently wrapped
    # around and returned invalid probabilities from n = 72 onwards (#219)
    @testset "signrank: large n" begin
        @testset "n = $n" for n in (71, 72, 73, 74, 80, 100, 120, 200)
            # The distribution is symmetric about n * (n + 1) / 4
            W = (n * (n + 1)) ÷ 4
            @test signrankpdf(n, W) ≈ Rmath.dsignrank(W, n, false)
            @test signrankcdf(n, W) ≈ Rmath.psignrank(W, n, true, false)
            @test signrankccdf(n, W) ≈ Rmath.psignrank(W, n, false, false)
            # Deep in the left tail, where the probabilities are tiny but still normal
            W2 = W ÷ 3
            @test signrankpdf(n, W2) ≈ Rmath.dsignrank(W2, n, false)
            @test signrankcdf(n, W2) ≈ Rmath.psignrank(W2, n, true, false)
        end

        @testset "pdf sums to one, n = $n" for n in (70, 80, 100)
            @test sum(signrankpdf(n, W) for W in 0:((n * (n + 1)) ÷ 2)) ≈ 1
        end
    end

    rmathcomp_tests(
        "srdist", [
            ((1, 2), (0.0:0.2:5.0)),
            ((2, 2), (0.0:0.2:5.0)),
            ((5, 3), (0.0:0.2:5.0)),
            ((10, 2), (0.0:0.2:5.0)),
            ((10, 5), (0.0:0.2:5.0)),
            ((1, 2), (0.0f0:0.2f0:5.0f0)),
            ((1, 2), (Float16(0):Float16(0.2):Float16(5))),
            ((1, 2), ((0 // 1):(1 // 5):(5 // 1))),
        ]
    )

    rmathcomp_tests(
        "wilcox", [
            ((3, 4), -2:13),
            ((3, 4), -2.0:13.0),
            ((4, 3), -2:13),
            ((4, 4), -2:17),
            ((1, 7), -2:8),
            ((1, 7), -2:8),
        ]
    )


    @test wilcoxinvcdf.(10, 10, wilcoxcdf.(10, 10, -1:101)) == [0; 0:100; 100]
    @test wilcoxinvccdf.(10, 10, wilcoxccdf.(10, 10, -1:101)) == [0; 0:100; 100]
    @test wilcoxinvlogcdf.(10, 10, wilcoxlogcdf.(10, 10, 0:101)) == [0:100; 100]
    @test isnan(wilcoxinvlogcdf.(10, 10, wilcoxlogcdf(10, 10, -1)))
    @test wilcoxinvlogccdf.(10, 10, wilcoxlogccdf.(10, 10, -1:99)) == [0; 0:99]
    @test isnan(wilcoxinvlogccdf.(10, 10, wilcoxlogccdf.(10, 10, 100)))
    @test isnan(wilcoxinvlogccdf.(10, 10, wilcoxlogccdf.(10, 10, 101)))

    # Accumulating the partition counts in `Int` used to break down in two separate ways:
    # the counts themselves wrapped around and returned silently invalid probabilities (#220),
    # and their normaliser `binomial(nx + ny, nx)` threw an `OverflowError` from
    # nx + ny = 68 onwards (#219). The silent limit is the lower of the two, and it is set by
    # `binomial(nx + ny, nx)` rather than by `nx + ny`: the Löffler recurrence subtracts as
    # well as adds, so its intermediates overshoot the counts and wrap first. Unbalanced
    # groups therefore stayed correct much further out, which is why the cases below are not
    # all balanced.
    @testset "wilcox: large nx and ny" begin
        @testset "nx = $nx, ny = $ny" for (nx, ny) in (
                (32, 32), (33, 33), (34, 34), (40, 40), (50, 50),
                (30, 36), (20, 48), (20, 60), (10, 325), (10, 326), (5, 200), (150, 40),
            )
            # The distribution is symmetric about nx * ny / 2
            U = (nx * ny) ÷ 2
            @test wilcoxpdf(nx, ny, U) ≈ Rmath.dwilcox(U, nx, ny, false)
            @test wilcoxcdf(nx, ny, U) ≈ Rmath.pwilcox(U, nx, ny, true, false)
            @test wilcoxccdf(nx, ny, U) ≈ Rmath.pwilcox(U, nx, ny, false, false)
            # Deep in the left tail, where the probabilities are tiny but still normal
            U2 = U ÷ 3
            @test wilcoxpdf(nx, ny, U2) ≈ Rmath.dwilcox(U2, nx, ny, false)
            @test wilcoxcdf(nx, ny, U2) ≈ Rmath.pwilcox(U2, nx, ny, true, false)
        end

        @testset "pdf sums to one, nx = $nx, ny = $ny" for (nx, ny) in ((30, 30), (33, 33), (34, 34), (50, 50), (5, 200))
            @test sum(wilcoxpdf(nx, ny, U) for U in 0:(nx * ny)) ≈ 1
        end

        # `1 / binomial(nx + ny, nx)` is the probability of the least likely outcome and
        # leaves the normal range from nx + ny = 1030. It seeds the recurrence, which is
        # homogeneous, so once it reaches zero every probability follows it and the results
        # are silently zero rather than merely imprecise. The recurrence therefore works in
        # units of a power of two, which these check has not disturbed anything.
        @testset "seed below the normal range, nx = ny = $m" for m in (515, 520, 530, 535)
            # the pdf at U = 0 is exactly the seed, so this pins the scaling down directly
            @test wilcoxpdf(m, m, 0) ≈ Float64(1 / BigFloat(binomial(big(2m), big(m)), precision = 512))
        end

        @testset "seed at zero without scaling" begin
            # `1 / binomial(1080, 524)` is zero in `Float64`, so every one of these was
            # exactly 0.0 before the recurrence was rescaled
            @test 0 < wilcoxpdf(524, 556, 20000) < 1
            @test 0 < wilcoxcdf(524, 556, 20000) < 1
            @test wilcoxpdf(524, 556, 20000) <= wilcoxcdf(524, 556, 20000)
            @test wilcoxcdf(524, 556, 20000) < wilcoxcdf(524, 556, 20001)
        end
    end

    # Note: Convergence fails in srdist with cdf values below 0.16 with df = 10, k = 5.
    # Reduced df or k allows convergence. This test documents this behavior.
    x = 0.15
    q = srdistcdf(10, 5, 0.15)
    rx = srdistinvcdf(10, 5, q)
    rtol = 100eps(1.0)
    @test_broken x ≈ rx atol = rtol rtol = rtol nans = true

    # `nranges=1` must be passed to Rmath.ptukey/qtukey; without it the Bool
    # flags shift into the `nranges` slot and CDF↔CCDF invert.
    @testset "srdist boundary behaviour" begin
        @test iszero(srdistcdf(2.0, 2.0, 0.0))
        @test isone(srdistccdf(2.0, 2.0, 0.0))
        @test srdistlogcdf(2.0, 2.0, 0.0) == -Inf
        @test iszero(srdistlogccdf(2.0, 2.0, 0.0))
        @test isone(srdistcdf(2.0, 2.0, Inf))
        @test iszero(srdistccdf(2.0, 2.0, Inf))
        @test iszero(srdistlogcdf(2.0, 2.0, Inf))
        @test srdistlogccdf(2.0, 2.0, Inf) == -Inf
    end

    # Test values outside of the support
    rmathcomp_tests(
        "beta", [
            ((1.0, 1.0), [-10.0, -6.3, 2.1, 23.5]),
            ((1 // 1, 1 // 1), [-10 // 1, -63 // 10, 21 // 10, 47 // 2]),
            ((1, 1), [-10, -6, 2, 24]),
        ]
    )
    rmathcomp_tests(
        "binom", [
            ((5, 0.5), [-8, -2.3, 1.2, 5.4, 11.9]),
            ((5, 1 // 2), [-8, -23 // 10, 6 // 5, 27 // 5, 119 // 10]),
            ((5, 1 // 2), [-8, -2, 6, 12]),
        ]
    )
    rmathcomp_tests(
        "fdist", [
            ((1.0, 1.0), [-10.0, -6.3]),
            ((1 // 1, 1 // 1), [-10 // 1, -63 // 10]),
            ((1, 1), [-10, -6]),
        ]
    )
    rmathcomp_tests(
        "gamma", [
            ((1.0, 1.0), [-10.0, -6.3]),
            ((1 // 1, 1 // 1), [-10 // 1, -63 // 10]),
            ((1, 1), [-10, -6]),
        ]
    )
    rmathcomp_tests(
        "pois", [
            ((0.5,), [-10, -2.5, 1.3, 8.7]),
            ((1 // 2,), [-10, -5 // 2, 13 // 10, 87 // 10]),
            ((1,), [-10, -3]),
        ]
    )
end

# functions related to beta distributions

using HypergeometricFunctions: _₂F₁

# Julia implementations
betapdf(α::Real, β::Real, x::Real) = exp(betalogpdf(α, β, x))

betalogpdf(α::Real, β::Real, x::Real) = betalogpdf(promote(α, β, x)...)
function betalogpdf(α::T, β::T, x::T) where {T <: Real}
    # we ensure that `log(x)` and `log1p(-x)` do not error
    y = clamp(x, 0, 1)
    val = xlogy(α - 1, y) + xlog1py(β - 1, -y) - logbeta(α, β)
    return x < 0 || x > 1 ? oftype(val, -Inf) : val
end

function betacdf(α::Real, β::Real, x::Real)
    # Handle degenerate cases
    if iszero(α) && β > 0
        return float(last(promote(α, β, x, x >= 0)))
    elseif iszero(β) && α > 0
        return float(last(promote(α, β, x, x >= 1)))
    end

    return first(beta_inc(α, β, clamp(x, 0, 1)))
end

function betaccdf(α::Real, β::Real, x::Real)
    # Handle degenerate cases
    if iszero(α) && β > 0
        return float(last(promote(α, β, x, x < 0)))
    elseif iszero(β) && α > 0
        return float(last(promote(α, β, x, x < 1)))
    end

    return last(beta_inc(α, β, clamp(x, 0, 1)))
end

# The log version is currently based on non-log version. When the cdf is very small we shift
# to an implementation based on the hypergeometric function ₂F₁ to avoid underflow.
function betalogcdf(α::T, β::T, x::T) where {T <: Real}
    # Handle degenerate cases
    if iszero(α) && β > 0
        return log(last(promote(x, x >= 0)))
    elseif iszero(β) && α > 0
        return log(last(promote(x, x >= 1)))
    end

    _x = clamp(x, 0, 1)
    p, q = beta_inc(α, β, _x)
    if p < floatmin(p)
        # see https://dlmf.nist.gov/8.17#E8
        # we use E8 instead of E7 due to https://github.com/JuliaMath/HypergeometricFunctions.jl/issues/47
        return -log(α) + xlogy(α, _x) + xlog1py(β, -_x) + log(_₂F₁(promote(α + β, 1, α + 1, _x)...; method = :positive)) - logbeta(α, β)
    elseif p <= 0.7
        return log(p)
    else
        return log1p(-q)
    end
end
betalogcdf(α::Real, β::Real, x::Real) = betalogcdf(promote(α, β, x)...)

function betalogccdf(α::Real, β::Real, x::Real)
    # Handle degenerate cases
    if iszero(α) && β > 0
        return log(last(promote(α, β, x, x < 0)))
    elseif iszero(β) && α > 0
        return log(last(promote(α, β, x, x < 1)))
    end

    p, q = beta_inc(α, β, clamp(x, 0, 1))
    if q < 0.7
        return log(q)
    else
        return log1p(-p)
    end
end

function betainvcdf(α::Real, β::Real, p::Real)
    # Handle degenerate cases
    if 0 ≤ p ≤ 1
        if iszero(α) && β > 0
            return last(promote(α, β, p, false))
        elseif iszero(β) && α > 0
            return last(promote(α, β, p, p > 0))
        end
    end

    return first(beta_inc_inv(α, β, p))
end

function betainvccdf(α::Real, β::Real, p::Real)
    # Handle degenerate cases
    if 0 ≤ p ≤ 1
        if iszero(α) && β > 0
            return last(promote(α, β, p, p == 0))
        elseif iszero(β) && α > 0
            return last(promote(α, β, p, true))
        end
    end

    return last(beta_inc_inv(β, α, p))
end

# Rmath implementations
function betainvlogcdf(α::Real, β::Real, lq::Real)
    T = float(Base.promote_typeof(α, β, lq))
    return convert(T, Rmath.qbeta(lq, α, β, true, true))
end
function betainvlogccdf(α::Real, β::Real, lq::Real)
    T = float(Base.promote_typeof(α, β, lq))
    return convert(T, Rmath.qbeta(lq, α, β, false, true))
end

# Owen's T function
#
# Ported from Boost owen_t.hpp, which is Copyright Benjamin Sobotta 2012
#      Use, modification and distribution are subject to the
#      Boost Software License, Version 1.0. (http://www.boost.org/LICENSE_1_0.txt)
# Port by Steven G. Johnson, also under Boost Software License, Version 1.0.
#
# Algorithm based on Mike Patefield and David Tandy, "Fast and accurate calculation
# of Owen's T-function," Journal of Statistical Software, 5, pp. 1-25 (2000).

# P(-∞<Z<=x)-0.5 with Z being normally distributed.
owens_t_znorm1(x::Real) = erf(x * invsqrt2) / 2

# Auxiliary function, it computes an array key that is used to determine
# the specific computation method for Owen's T and the order thereof
# used in owens_t_dispatch.  Differs from C++ in using 1-based indices
const owens_t_hrange = (0.02f0, 0.06f0, 0.09f0, 0.125f0, 0.26f0, 0.4f0, 0.6f0, 1.6f0, 1.7f0, 2.33f0, 2.4f0, 3.36f0, 3.4f0, 4.8f0) # length 14
const owens_t_arange = (0.025f0, 0.09f0, 0.15f0, 0.36f0, 0.5f0, 0.9f0, 0.99999f0) # length 7
const owens_t_select = (
    1, 1, 2, 13, 13, 13, 13, 13, 13, 13, 13, 16, 16, 16, 9,
    1, 2, 2, 3, 3, 5, 5, 14, 14, 15, 15, 16, 16, 16, 9,
    2, 2, 3, 3, 3, 5, 5, 15, 15, 15, 15, 16, 16, 16, 10,
    2, 2, 3, 5, 5, 5, 5, 7, 7, 16, 16, 16, 16, 16, 10,
    2, 3, 3, 5, 5, 6, 6, 8, 8, 17, 17, 17, 12, 12, 11,
    2, 3, 5, 5, 5, 6, 6, 8, 8, 17, 17, 17, 12, 12, 12,
    2, 3, 4, 4, 6, 6, 8, 8, 17, 17, 17, 17, 17, 12, 12,
    2, 3, 4, 4, 6, 6, 18, 18, 18, 18, 17, 17, 17, 12, 12,
) # 1-based indices (in 8x15 "matrix")
function owens_t_compute_code(h::Float64, a::Float64)
    ihint = something(findfirst(>=(h), owens_t_hrange), length(owens_t_hrange) + 1)
    iaint = something(findfirst(>=(a), owens_t_arange), length(owens_t_arange) + 1)
    return owens_t_select[(iaint - 1) * 15 + ihint]
end

const owens_t_ord = (2, 3, 4, 5, 7, 10, 12, 18, 10, 20, 30, 0, 4, 7, 8, 20, 0, 0) # 53-bit precision table
function owens_t_get_order(icode::Int, ::Type{Float64})
    return owens_t_ord[icode]
end

# compute the value of Owen's T function with method T1 from the reference paper
function owens_t_T1(h::Float64, a::Float64, m::Int)
    hs = -h * h / 2
    as = a * a
    aj = a * inv2π
    dj = expm1(hs)
    gj = hs * exp(hs)
    val = atan(a) * inv2π
    j, jj = one(m), oftype(h, 1)
    while true
        val += dj * aj / jj
        m <= j && break
        j += one(m)
        jj += 2
        aj *= as
        dj = gj - dj
        gj *= hs / j
    end
    return val
end

# compute the value of Owen's T function with method T2 from the reference paper
function owens_t_T2(h::Float64, a::Float64, m::Int, ah::Float64)
    maxii = m + m + one(m)
    hs = h * h
    as = -a * a
    y = inv(hs)
    ii = one(m)
    val = zero(h)
    vi = a * normpdf(ah)
    z = owens_t_znorm1(ah) / h
    while true
        val += z
        maxii <= ii && break
        z = y * (vi - ii * z)
        vi *= as
        ii += oftype(ii, 2)
    end
    return val * normpdf(h)
end

# compute the value of Owen's T function with method T3 from the reference paper
const owens_t_c2 = (
    0.9999999999999998751, -0.99999999999988796462, 0.99999999998290743652,
    -0.99999999896282500134, 0.99999996660459362918, -0.9999993398627247676,
    0.99999125611136965852, -0.99991777624463387686, 0.99942835555870132569,
    -0.99697311720723000295, 0.98751448037275303682, -0.95915857980572882813,
    0.89246305511006708555, -0.76893425990463999675, 0.5889352846848469325,
    -0.38380345160440256652, 0.20317601701045299653, -0.82813631607004984866e-1,
    0.24167984735759576523e-1, -0.44676566663971825242e-2, 0.39141169402373836468e-3,
)
function owens_t_T3(h::Float64, a::Float64, ah::Float64)
    as = a * a
    hs = h * h
    y = inv(hs)
    ii = one(h)
    vi = a * normpdf(ah)
    zi = owens_t_znorm1(ah) / h
    val = zero(h)
    i = 1
    while true
        val += zi * owens_t_c2[i]
        i == lastindex(owens_t_c2) && break
        i += 1
        zi = y * (ii * zi - vi)
        vi *= as
        ii += 2
    end
    return val * normpdf(h)
end

# compute the value of Owen's T function with method T4 from the reference paper
function owens_t_T4(h::Float64, a::Float64, m::Int)
    maxii = m + m + one(m)
    hs = h * h
    as = -a * a
    ii = 1
    ai = a * exp(-hs * (1 - as) / 2) * inv2π
    yi = one(h)
    val = zero(h)
    while true
        val += ai * yi
        maxii <= ii && break
        ii += 2
        yi = (1 - hs * yi) / ii
        ai *= as
    end
    return val
end

# compute the value of Owen's T function with method T5 from the reference paper
const owens_t_pts = (
    0.35082039676451715489e-2, 0.3127904233803075374e-1, 0.8526682628321945109e-1,
    0.16245071730812277011, 0.25851196049125434828, 0.36807553840697533536,
    0.48501092905604697475, 0.60277514152618576821, 0.71477884217753226516,
    0.81475510988760098605, 0.89711029755948965867, 0.95723808085944261843, 0.99178832974629703586,
)
const owens_t_wts = (
    0.18831438115323502887e-1, 0.18567086243977649478e-1, 0.18042093461223385584e-1,
    0.17263829606398753364e-1, 0.1624321997598985673e-1, 0.14994592034116704829e-1,
    0.13535474469662088392e-1, 0.11886351605820165233e-1, 0.10070377242777431897e-1,
    0.81130545742299586629e-2, 0.60419009528470238773e-2, 0.38862217010742057883e-2, 0.16793031084546090448e-2,
)
#=
    NOTICE:
    - The pts[] array contains the squares (!) of the abscissas, i.e. the roots of the Legendre
        polynomial P_n(x), instead of the plain roots as required in Gauss-Legendre
        quadrature, because T5(h,a,m) contains only x^2 terms.
    - The wts[] array contains the weights for Gauss-Legendre quadrature scaled with a factor
        of 1/(2*pi) according to T5(h,a,m).
=#
function owens_t_T5(h::Float64, a::Float64)
    as = a * a
    hs = -h * h / 2
    r = 1 .+ as .* owens_t_pts
    return sum(owens_t_wts .* exp.(hs .* r) ./ r) * a
end

# compute the value of Owen's T function with method T6 from the reference paper
function owens_t_T6(h::Float64, a::Float64)
    normh = normccdf(h)
    y = 1 - a
    r = atan(y, 1 + a)
    val = normh * (1 - normh) / 2
    !iszero(r) && (val -= r * exp(-y * h * h / 2r) * inv2π)
    return val
end

# This routine dispatches the call to one of six subroutines, depending on the values of h and a.
# preconditions: h >= 0, 0<=a<=1, ah=a*h.
# Simple main case for 64-bit precision or less, this is as per the Patefield-Tandy paper:
function owens_t_dispatch(h::Float64, a::Float64, ah::Float64)
    # Handle some special cases first, these are from
    # page 1077 of Owen's original paper:
    iszero(h) && return atan(a) * inv2π
    iszero(a) && return zero(h)
    a == 1 && return normccdf(-h) * normccdf(h) / 2
    @assert a <= 1 # when a>1 we call this routine with 1/a:

    icode = owens_t_compute_code(h, a)
    m = owens_t_get_order(icode, typeof(h))
    meth = (1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 3, 4, 4, 4, 4, 5, 6) # 18 entries
    method = meth[icode]

    # determine the appropriate method, T1 ... T6
    method == 1 && return owens_t_T1(h, a, m)
    method == 2 && return owens_t_T2(h, a, m, ah)
    method == 3 && return owens_t_T3(h, a, ah)
    method == 4 && return owens_t_T4(h, a, m)
    method == 5 && return owens_t_T5(h, a)
    return owens_t_T6(h, a)
end

# compute Owen's T function, T(h,a), for arbitrary values of h and a
function _owens_t(h::Float64, a::Float64)
    # exploit that T(-h,a) == T(h,a)
    h = abs(h)

    # Use equation (2) in the paper to remap the arguments
    # such that h>=0 and 0<=a<=1 for the call of the actual
    # computation routine.
    abs_a = abs(a)
    abs_ah = abs_a * h

    val = if abs_a <= 1
        owens_t_dispatch(h, abs_a, abs_ah)
    elseif !isfinite(abs_a)
        isnan(abs_a) ? oftype(h, NaN) : normcdf(-h) / 2
    elseif h <= oftype(h, 0.67)
        normh = owens_t_znorm1(h)
        normah = owens_t_znorm1(abs_ah)
        1 // 4 - normh * normah - owens_t_dispatch(abs_ah, inv(abs_a), h)
    else
        normh = normccdf(h)
        normah = normccdf(abs_ah)
        (normh + normah) / 2 - normh * normah - owens_t_dispatch(abs_ah, inv(abs_a), h)
    end
    return copysign(val, a) # exploit that T(h,-a) == -T(h,a)
end

_owens_t(h::Float32, a::Float32) = Float32(owens_t(Float64(h), Float64(a)))
_owens_t(h::Float16, a::Float16) = Float16(owens_t(Float64(h), Float64(a)))

"""
    owens_t(h::Real, a::Real)

Return [Owen's T function](https://en.wikipedia.org/wiki/Owen%27s_T_function)

```math
T(h, a) = \\frac{1}{2\\pi} \\int_0^a \\frac{e^{-h^2(1+x^2)/2}}{1 + x^2} \\, dx
```

This is the probability of ``X > h`` and ``0 < Y < aX``, where ``X`` and ``Y`` are
i.i.d. standard normal random variables.
"""
owens_t(h::Real, a::Real) = _owens_t(map(float, promote(h, a))...)

using StatsFuns, Test

@testset "bvncdf: bivariate normal cdf" begin

    @test bvncdf(0.0, 0.0, 0.0) == 0.25
    @test bvncdf(0.0, Inf, 0.0) == 0.5
    @test bvncdf(Inf, 0.0, 0.0) == 0.5
    @test bvncdf(Inf, Inf, 0.0) == 1.0

    for r in -1.0:0.25:1.0
        for x in -10.0:0.5:10.0
            @test bvncdf(x, Inf, r) == normcdf(x)
            @test bvncdf(Inf, x, r) == normcdf(x)
            @test bvncdf(x, -Inf, r) == 0.0
            @test bvncdf(-Inf, x, r) == 0.0
        end
    end

    @test_throws DomainError bvncdf(0.0, 0.0, -2.0)
    @test_throws DomainError bvncdf(0.0, 0.0, 2.0)

    @test bvncdf(0.0, -100000.0, 0.0) ≈ 0.0
    @test bvncdf(0.0, 100000.0, 0.0) ≈ 0.5
    @test bvncdf(100000.0, 100000.0, 0.0) ≈ 1.0
    @test bvncdf(-100000.0, 100000.0, 0.0) ≈ 0.0

    for x in -100.0:100.0, y in -100.0:100.0, r in -1.0:0.1:1.0
        @test !isnan(bvncdf(x, y, r))
    end
end

# functions related to chi-square distribution

# Just use the Gamma definitions
for f in ("pdf", "logpdf", "cdf", "ccdf", "logcdf", "logccdf", "invcdf", "invccdf", "invlogcdf", "invlogccdf")
    _chisqf = Symbol("chisq" * f)
    _gammaf = Symbol("gamma" * f)
    @eval begin
        $(_chisqf)(k::Real, x::Real) = $(_chisqf)(promote(k, x)...)
        $(_chisqf)(k::T, x::T) where {T <: Real} = $(_gammaf)(k / 2, 2, x)
    end
end

module StatsFuns

using Base: Math.@horner
using Reexport: @reexport
using Rmath: Rmath
using SpecialFunctions: beta_inc, beta_inc_inv, digamma,
    erf, erfc, erfcinv, erfcx, gamma_inc, gamma_inc_inv, logabsbinomial, logbeta, loggamma

# reexports
@reexport using IrrationalConstants:
    twoπ, # 2π
    fourπ, # 4π
    halfπ, # π / 2
    quartπ, # π / 4
    invπ, # 1 / π
    twoinvπ, # 2 / π
    fourinvπ, # 4 / π
    inv2π, # 1 / (2π)
    inv4π, # 1 / (4π)
    sqrt2, # √2
    sqrt3, # √3
    sqrtπ, # √π
    sqrt2π, # √2π
    sqrt4π, # √4π
    sqrthalfπ, # √(π / 2)
    invsqrt2, # 1 / √2
    invsqrt2π, # 1 / √2π
    loghalf, # log(1 / 2)
    logtwo, # log(2)
    logπ, # log(π)
    log2π, # log(2π)
    log4π       # log(4π)

@reexport using LogExpFunctions:
    xlogx, # x * log(x) for x > 0, or 0 when x == 0
    xlogy, # x * log(y) for x > 0, or 0 when x == 0
    xlog1py, # x * log(1 + y) for x > 0, or 0 when x == 0
    logistic, # 1 / (1 + exp(-x))
    logit, # log(x / (1 - x))
    log1psq, # log(1 + x^2)
    log1pexp, # log(1 + exp(x))
    log1mexp, # log(1 - exp(x))
    log2mexp, # log(2 - exp(x))
    logexpm1, # log(exp(x) - 1)
    softplus, # alias of log1pexp
    invsoftplus, # alias of logexpm1
    log1pmx, # log(1 + x) - x
    logmxp1, # log(x) - x + 1
    logaddexp, # log(exp(x) + exp(y))
    logsubexp, # log(abs(e^x - e^y))
    logsumexp, # log(sum(exp(x)))
    softmax, # exp(x_i) / sum(exp(x)), for i
    softmax!        # inplace softmax

export
    # distrs/beta
    betapdf, # pdf of beta distribution
    betalogpdf, # logpdf of beta distribution
    betacdf, # cdf of beta distribution
    betaccdf, # ccdf of beta distribution
    betalogcdf, # logcdf of beta distribution
    betalogccdf, # logccdf of beta distribution
    betainvcdf, # inverse-cdf of beta distribution
    betainvccdf, # inverse-ccdf of beta distribution
    betainvlogcdf, # inverse-logcdf of beta distribution
    betainvlogccdf, # inverse-logccdf of beta distribution

    # distrs/binom
    binompdf, # pdf of binomial distribution
    binomlogpdf, # logpdf of binomial distribution
    binomcdf, # cdf of binomial distribution
    binomccdf, # ccdf of binomial distribution
    binomlogcdf, # logcdf of binomial distribution
    binomlogccdf, # logccdf of binomial distribution
    binominvcdf, # inverse-cdf of binomial distribution
    binominvccdf, # inverse-ccdf of binomial distribution
    binominvlogcdf, # inverse-logcdf of binomial distribution
    binominvlogccdf, # inverse-logccdf of binomial distribution

    # distrs/chisq
    chisqpdf, # pdf of chi-square distribution
    chisqlogpdf, # logpdf of chi-square distribution
    chisqcdf, # cdf of chi-square distribution
    chisqccdf, # ccdf of chi-square distribution
    chisqlogcdf, # logcdf of chi-square distribution
    chisqlogccdf, # logccdf of chi-square distribution
    chisqinvcdf, # inverse-cdf of chi-square distribution
    chisqinvccdf, # inverse-ccdf of chi-square distribution
    chisqinvlogcdf, # inverse-logcdf of chi-square distribution
    chisqinvlogccdf, # inverse-logccdf of chi-square distribution

    # distrs/fdist
    fdistpdf, # pdf of F distribution
    fdistlogpdf, # logpdf of F distribution
    fdistcdf, # cdf of F distribution
    fdistccdf, # ccdf of F distribution
    fdistlogcdf, # logcdf of F distribution
    fdistlogccdf, # logccdf of F distribution
    fdistinvcdf, # inverse-cdf of F distribution
    fdistinvccdf, # inverse-ccdf of F distribution
    fdistinvlogcdf, # inverse-logcdf of F distribution
    fdistinvlogccdf, # inverse-logccdf of F distribution

    # distrs/gamma
    gammapdf, # pdf of gamma distribution
    gammalogpdf, # logpdf of gamma distribution
    gammacdf, # cdf of gamma distribution
    gammaccdf, # ccdf of gamma distribution
    gammalogcdf, # logcdf of gamma distribution
    gammalogccdf, # logccdf of gamma distribution
    gammainvcdf, # inverse-cdf of gamma distribution
    gammainvccdf, # inverse-ccdf of gamma distribution
    gammainvlogcdf, # inverse-logcdf of gamma distribution
    gammainvlogccdf, # inverse-logccdf of gamma distribution

    # distrs/hyper
    hyperpdf, # pdf of hypergeometric distribution
    hyperlogpdf, # logpdf of hypergeometric distribution
    hypercdf, # cdf of hypergeometric distribution
    hyperccdf, # ccdf of hypergeometric distribution
    hyperlogcdf, # logcdf of hypergeometric distribution
    hyperlogccdf, # logccdf of hypergeometric distribution
    hyperinvcdf, # inverse-cdf of hypergeometric distribution
    hyperinvccdf, # inverse-ccdf of hypergeometric distribution
    hyperinvlogcdf, # inverse-logcdf of hypergeometric distribution
    hyperinvlogccdf, # inverse-logccdf of hypergeometric distribution

    # distrs/nbeta
    nbetapdf, # pdf of noncentral beta distribution
    nbetalogpdf, # logpdf of noncentral beta distribution
    nbetacdf, # cdf of noncentral beta distribution
    nbetaccdf, # ccdf of noncentral beta distribution
    nbetalogcdf, # logcdf of noncentral beta distribution
    nbetalogccdf, # logccdf of noncentral beta distribution
    nbetainvcdf, # inverse-cdf of noncentral beta distribution
    nbetainvccdf, # inverse-ccdf of noncentral beta distribution
    nbetainvlogcdf, # inverse-logcdf of noncentral beta distribution
    nbetainvlogccdf, # inverse-logccdf of noncentral beta distribution

    # distrs/nbinom
    nbinompdf, # pdf of negative nbinomial distribution
    nbinomlogpdf, # logpdf of negative nbinomial distribution
    nbinomcdf, # cdf of negative nbinomial distribution
    nbinomccdf, # ccdf of negative nbinomial distribution
    nbinomlogcdf, # logcdf of negative nbinomial distribution
    nbinomlogccdf, # logccdf of negative nbinomial distribution
    nbinominvcdf, # inverse-cdf of negative nbinomial distribution
    nbinominvccdf, # inverse-ccdf of negative nbinomial distribution
    nbinominvlogcdf, # inverse-logcdf of negative nbinomial distribution
    nbinominvlogccdf, # inverse-logccdf of negative nbinomial distribution

    # distrs/nchisq
    nchisqpdf, # pdf of noncentral chi-square distribution
    nchisqlogpdf, # logpdf of noncentral chi-square distribution
    nchisqcdf, # cdf of noncentral chi-square distribution
    nchisqccdf, # ccdf of noncentral chi-square distribution
    nchisqlogcdf, # logcdf of noncentral chi-square distribution
    nchisqlogccdf, # logccdf of noncentral chi-square distribution
    nchisqinvcdf, # inverse-cdf of noncentral chi-square distribution
    nchisqinvccdf, # inverse-ccdf of noncentral chi-square distribution
    nchisqinvlogcdf, # inverse-logcdf of noncentral chi-square distribution
    nchisqinvlogccdf, # inverse-logccdf of noncentral chi-square distribution

    # distrs/nfdist
    nfdistpdf, # pdf of noncentral F distribution
    nfdistlogpdf, # logpdf of noncentral F distribution
    nfdistcdf, # cdf of noncentral F distribution
    nfdistccdf, # ccdf of noncentral F distribution
    nfdistlogcdf, # logcdf of noncentral F distribution
    nfdistlogccdf, # logccdf of noncentral F distribution
    nfdistinvcdf, # inverse-cdf of noncentral F distribution
    nfdistinvccdf, # inverse-ccdf of noncentral F distribution
    nfdistinvlogcdf, # inverse-logcdf of noncentral F distribution
    nfdistinvlogccdf, # inverse-logccdf of noncentral F distribution

    # distrs/norm
    normpdf, # pdf of normal distribution
    normlogpdf, # logpdf of normal distribution
    normcdf, # cdf of normal distribution
    normccdf, # ccdf of normal distribution
    normlogcdf, # logcdf of normal distribution
    normlogccdf, # logccdf of normal distribution
    norminvcdf, # inverse-cdf of normal distribution
    norminvccdf, # inverse-ccdf of normal distribution
    norminvlogcdf, # inverse-logcdf of normal distribution
    norminvlogccdf, # inverse-logccdf of normal distribution

    # distrs/ntdist
    ntdistpdf, # pdf of noncentral t distribution
    ntdistlogpdf, # logpdf of noncentral t distribution
    ntdistcdf, # cdf of noncentral t distribution
    ntdistccdf, # ccdf of noncentral t distribution
    ntdistlogcdf, # logcdf of noncentral t distribution
    ntdistlogccdf, # logccdf of noncentral t distribution
    ntdistinvcdf, # inverse-cdf of noncentral t distribution
    ntdistinvccdf, # inverse-ccdf of noncentral t distribution
    ntdistinvlogcdf, # inverse-logcdf of noncentral t distribution
    ntdistinvlogccdf, # inverse-logccdf of noncentral t distribution

    # distrs/pois
    poispdf, # pdf of Poisson distribution
    poislogpdf, # logpdf of Poisson distribution
    poiscdf, # cdf of Poisson distribution
    poisccdf, # ccdf of Poisson distribution
    poislogcdf, # logcdf of Poisson distribution
    poislogccdf, # logccdf of Poisson distribution
    poisinvcdf, # inverse-cdf of Poisson distribution
    poisinvccdf, # inverse-ccdf of Poisson distribution
    poisinvlogcdf, # inverse-logcdf of Poisson distribution
    poisinvlogccdf, # inverse-logccdf of Poisson distribution

    # distrs/tdist
    tdistpdf, # pdf of student's t distribution
    tdistlogpdf, # logpdf of student's t distribution
    tdistcdf, # cdf of student's t distribution
    tdistccdf, # ccdf of student's t distribution
    tdistlogcdf, # logcdf of student's t distribution
    tdistlogccdf, # logccdf of student's t distribution
    tdistinvcdf, # inverse-cdf of student's t distribution
    tdistinvccdf, # inverse-ccdf of student's t distribution
    tdistinvlogcdf, # inverse-logcdf of student's t distribution
    tdistinvlogccdf, # inverse-logccdf of student's t distribution

    # distrs/signrank
    signrankpdf,
    signranklogpdf,
    signrankcdf,
    signranklogcdf,
    signrankccdf,
    signranklogccdf,
    signrankinvcdf,
    signrankinvccdf,
    signrankinvlogcdf,
    signrankinvlogccdf,

    # distrs/srdist
    srdistcdf, # cdf of studentized range distribution
    srdistccdf, # ccdf of studentized range distribution
    srdistlogcdf, # logcdf of studentized range distribution
    srdistlogccdf, # logccdf of studentized range distribution
    srdistinvcdf, # inverse-cdf of studentized range distribution
    srdistinvccdf, # inverse-ccdf of studentized range distribution
    srdistinvlogcdf, # inverse-logcdf of studentized range distribution
    srdistinvlogccdf, # inverse-logccdf of studentized range distribution

    # distrs/wilcox
    wilcoxpdf,
    wilcoxlogpdf,
    wilcoxcdf,
    wilcoxlogcdf,
    wilcoxccdf,
    wilcoxlogccdf,
    wilcoxinvcdf,
    wilcoxinvccdf,
    wilcoxinvlogcdf,
    wilcoxinvlogccdf,

    # misc
    logmvgamma, # logarithm of multivariate gamma function
    logmvbeta, # logarithm of multivariate beta function
    lstirling_asym,

    # owens_t
    owens_t,

    # tvpack
    bvncdf    # bivariate standard normal cdf

## source files
include("misc.jl")
include("owens_t.jl")
include("tvpack.jl")

include("distrs/beta.jl")
include("distrs/binom.jl")
include("distrs/chisq.jl")
include("distrs/fdist.jl")
include("distrs/gamma.jl")
include("distrs/hyper.jl")
include("distrs/nbeta.jl")
include("distrs/nbinom.jl")
include("distrs/nchisq.jl")
include("distrs/nfdist.jl")
include("distrs/norm.jl")
include("distrs/ntdist.jl")
include("distrs/pois.jl")
include("distrs/tdist.jl")
include("distrs/signrank.jl")
include("distrs/srdist.jl")
include("distrs/wilcox.jl")

end # module
